=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2013-11-18 23:41:30 +0000
+++ CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -163,6 +163,8 @@
 # Add subdirectories.
 add_subdirectory(include)
 add_subdirectory(src)
+add_subdirectory(scoperegistry)
+add_subdirectory(scoperunner)
 add_subdirectory(data)
 add_subdirectory(test)
 add_subdirectory(demo)

=== modified file 'demo/CMakeLists.txt'
--- demo/CMakeLists.txt	2013-09-23 06:13:06 +0000
+++ demo/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,27 +1,11 @@
+add_subdirectory(scopes)
+add_subdirectory(scope-groups)
+
 configure_file(Factory.ini.in Factory.ini)
-configure_file(RegistryMain.ini.in RegistryMain.ini)
 configure_file(Runtime.ini.in Runtime.ini)
 configure_file(Registry.ini.in Registry.ini)
-configure_file(Zmq.Registry.ini.in Zmq.Registry.ini)
 configure_file(Zmq.ini.in Zmq.ini)
 
-add_library(scope-A MODULE scope-A.cpp)
-add_library(scope-B MODULE scope-B.cpp)
-add_library(scope-C MODULE scope-C.cpp)
-add_library(scope-D MODULE scope-D.cpp)
-add_library(scope-slow MODULE scope-slow.cpp)
-
-add_executable(scoperunner-A scoperunner-A.cpp)
-target_link_libraries(scoperunner-A ${UNITY_SCOPES_LIB} ${OTHER_LIBS})
-
-add_executable(scoperunner-BC scoperunner-BC.cpp)
-target_link_libraries(scoperunner-BC ${UNITY_SCOPES_LIB} ${OTHER_LIBS})
-
-add_executable(scoperunner-D scoperunner-D.cpp)
-target_link_libraries(scoperunner-D ${UNITY_SCOPES_LIB} ${OTHER_LIBS})
-
-add_executable(scoperunner-slow scoperunner-slow.cpp)
-target_link_libraries(scoperunner-slow ${UNITY_SCOPES_LIB} ${OTHER_LIBS})
 
 add_executable(client client.cpp)
 target_link_libraries(client ${UNITY_SCOPES_LIB} ${OTHER_LIBS})

=== modified file 'demo/Factory.ini.in'
--- demo/Factory.ini.in	2013-09-23 06:13:06 +0000
+++ demo/Factory.ini.in	2013-11-19 02:51:46 +0000
@@ -1,2 +1,2 @@
 [MiddlewareFactory]
-Zmq.Configfile = Zmq.ini
+Zmq.Configfile = @CMAKE_CURRENT_BINARY_DIR@/Zmq.ini

=== added file 'demo/README'
--- demo/README	1970-01-01 00:00:00 +0000
+++ demo/README	2013-11-19 02:51:46 +0000
@@ -0,0 +1,31 @@
+Leaf scopes in this demo:
+
+- scope-A: returns 1 result
+- scope-C: returns 3 results
+- scope-D: returns 4 results
+- scope-N: minimal no-op scope that illustrates the simplest possible implementation
+- scope-S: slow scope; returns 1 result after 20 seconds
+
+Aggregating scopes:
+
+- scope-B aggregates from scope-C and scope-D, so it returns 7 results
+
+Processes:
+
+The scopes run as separate process, except for scope-B and scope-C, which run collocated in a single process.
+
+To start the registry, which automatically starts the processes, run
+
+$ ../scoperegistry/scoperegistry Runtime.ini
+
+You do not need to run the registry from the current directory. Just adjust the path to Runtime.ini to point at the Runtime.ini file in *this* directory.
+
+To send a query to a scope, run
+
+$ ./client <scope-letter> <query-string>
+
+For example:
+
+$ ./client B testquery
+
+TODO: The client currently looks for Runtime.ini in the current directory, so you need to run it from here.

=== modified file 'demo/Registry.ini.in'
--- demo/Registry.ini.in	2013-09-23 06:13:06 +0000
+++ demo/Registry.ini.in	2013-11-19 02:51:46 +0000
@@ -1,4 +1,8 @@
 [Registry]
 Middleware = Zmq
-Zmq.Endpoint = ipc://Registry
-Zmq.Configfile = Zmq.ini
+Zmq.Endpoint = ipc:///tmp/Registry
+Zmq.EndpointDir = /tmp
+Zmq.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Zmq.ini
+Scope.InstallDir = @CMAKE_CURRENT_BINARY_DIR@/scopes
+Scope.GroupConfigDir = @CMAKE_CURRENT_BINARY_DIR@/scope-groups
+Scoperunner.Path = @CMAKE_BINARY_DIR@/scoperunner/scoperunner

=== removed file 'demo/RegistryMain.ini.in'
--- demo/RegistryMain.ini.in	2013-09-23 06:13:06 +0000
+++ demo/RegistryMain.ini.in	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-[Runtime]
-Registry.Identity = Registry
-Registry.Configfile = Registry.ini
-Default.Middleware = Zmq
-Zmq.Configfile = Zmq.ini
-Factory.Configfile = Factory.ini

=== modified file 'demo/Runtime.ini.in'
--- demo/Runtime.ini.in	2013-09-23 06:13:06 +0000
+++ demo/Runtime.ini.in	2013-11-19 02:51:46 +0000
@@ -1,6 +1,6 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Registry.ini
 Default.Middleware = Zmq
-Zmq.Configfile = Zmq.ini
-Factory.Configfile = Factory.ini
+Zmq.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Zmq.ini
+Factory.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Factory.ini

=== removed file 'demo/Zmq.Registry.ini.in'
--- demo/Zmq.Registry.ini.in	2013-09-23 06:13:06 +0000
+++ demo/Zmq.Registry.ini.in	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-[wom]

=== modified file 'demo/Zmq.ini.in'
--- demo/Zmq.ini.in	2013-09-23 06:13:06 +0000
+++ demo/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -1,1 +1,3 @@
 [Zmq]
+EndpointDir.Public = /tmp
+EndpointDir.Private = @CMAKE_CURRENT_BINARY_DIR@

=== modified file 'demo/client.cpp'
--- demo/client.cpp	2013-11-12 14:58:21 +0000
+++ demo/client.cpp	2013-11-19 02:51:46 +0000
@@ -42,8 +42,10 @@
     virtual void finished() override
     {
         cout << "query complete" << endl;
-        unique_lock<decltype(mutex_)> lock(mutex_);
-        query_complete_ = true;
+        {
+            unique_lock<decltype(mutex_)> lock(mutex_);
+            query_complete_ = true;
+        }
         condvar_.notify_one();
     }
 
@@ -86,7 +88,7 @@
         VariantMap vm;
         vm["cardinality"] = 10;
         vm["locale"] = "C";
-        s->create_query(search_string, vm, reply);     // Returns immediately
+        auto ctrl = s->create_query(search_string, vm, reply);     // Returns (almost) immediately
         cerr << "client: created query" << endl;
         reply->wait_until_finished();
         cerr << "client: wait returned" << endl;

=== removed file 'demo/scope-A.cpp'
--- demo/scope-A.cpp	2013-11-14 10:18:32 +0000
+++ demo/scope-A.cpp	1970-01-01 00:00:00 +0000
@@ -1,103 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/ScopeBase.h>
-#include <scopes/Reply.h>
-#include <scopes/Category.h>
-#include <scopes/ResultItem.h>
-
-#include <iostream>
-
-#define EXPORT __attribute__ ((visibility ("default")))
-
-using namespace std;
-using namespace unity::api::scopes;
-
-// Example scope A: replies synchronously to a query. (Replies are returned before returning from the run() method.)
-
-class MyQuery : public QueryBase
-{
-public:
-    MyQuery(string const& query) :
-        query_(query)
-    {
-    }
-
-    ~MyQuery() noexcept
-    {
-    }
-
-    virtual void cancelled() override
-    {
-    }
-
-    virtual void run(ReplyProxy const& reply) override
-    {
-        auto cat = std::shared_ptr<Category>(new Category("cat1"));
-        ResultItem res(cat);
-        res.set_uri("uri");
-        res.set_title("scope-A: result 1 for query \"" + query_ + "\"");
-        res.set_icon("icon");
-        res.set_dnd_uri("dnd_uri");
-        reply->push(res);
-        cout << "scope-A: query \"" << query_ << "\" complete" << endl;
-    }
-
-private:
-    string query_;
-};
-
-class MyScope : public ScopeBase
-{
-public:
-    virtual int start(string const&, RegistryProxy const&) override
-    {
-        return VERSION;
-    }
-
-    virtual void stop() override {}
-    virtual void run() override {}
-
-    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
-    {
-        QueryBase::UPtr query(new MyQuery(q));
-        cout << "scope-A: created query: \"" << q << "\"" << endl;
-        return query;
-    }
-};
-
-extern "C"
-{
-
-    EXPORT
-    unity::api::scopes::ScopeBase*
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_CREATE_FUNCTION()
-    {
-        return new MyScope;
-    }
-
-    EXPORT
-    void
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
-    {
-        delete scope_base;
-    }
-
-}

=== removed file 'demo/scope-B.cpp'
--- demo/scope-B.cpp	2013-11-12 14:58:21 +0000
+++ demo/scope-B.cpp	1970-01-01 00:00:00 +0000
@@ -1,147 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/Registry.h>
-#include <scopes/Reply.h>
-#include <scopes/ResultItem.h>
-#include <scopes/ScopeBase.h>
-#include <unity/UnityExceptions.h>
-
-#include <iostream>
-
-#define EXPORT __attribute__ ((visibility ("default")))
-
-using namespace std;
-using namespace unity::api::scopes;
-
-// Example scope B: aggregates from scope C and D.
-
-// A Reply instance remembers the query string and the reply object that was passed
-// from upstream. Results from the child scopes are sent to that upstream reply object.
-
-class SubReply : public ReplyBase
-{
-public:
-    virtual void push(ResultItem const& result) override
-    {
-        cout << "received result from " << scope_name_ << ": " << result.uri() << ", " << result.title() << endl;
-        upstream_->push(result);
-    }
-
-    virtual void finished() override
-    {
-        cout << "query to " << scope_name_ << " complete" << endl;
-    }
-
-    SubReply(string const& scope_name, ReplyProxy const& upstream) :
-        scope_name_(scope_name),
-        upstream_(upstream)
-    {
-    }
-
-private:
-    string scope_name_;
-    ReplyProxy upstream_;
-};
-
-class MyQuery : public QueryBase
-{
-public:
-    MyQuery(string const& scope_name,
-            string const& query,
-            ScopeProxy const& scope_c,
-            ScopeProxy const& scope_d) :
-        scope_name_(scope_name),
-        query_(query),
-        scope_c_(scope_c),
-        scope_d_(scope_d)
-    {
-    }
-
-    virtual void cancelled()
-    {
-        cout << "query to " << scope_name_ << " was cancelled" << endl;
-    }
-
-    virtual void run(ReplyProxy const& upstream_reply)
-    {
-        ReplyBase::SPtr reply(new SubReply(scope_name_, upstream_reply));
-        create_subquery(scope_c_, query_, VariantMap(), reply);
-        create_subquery(scope_d_, query_, VariantMap(), reply);
-    }
-
-private:
-    string scope_name_;
-    string query_;
-    ScopeProxy scope_c_;
-    ScopeProxy scope_d_;
-};
-
-// MyScope aggregates from C and D.
-
-class MyScope : public ScopeBase
-{
-public:
-    virtual int start(string const& scope_name, RegistryProxy const& registry) override
-    {
-        scope_name_ = scope_name;
-
-        // Lock up scopes C and D in the registry and remember their proxies.
-        scope_c_ = registry->find("scope-C");
-        scope_d_ = registry->find("scope-D");
-
-        return VERSION;
-    }
-
-    virtual void stop() override {}
-
-    virtual void run() override {}
-
-    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
-    {
-        QueryBase::UPtr query(new MyQuery(scope_name_, q, scope_c_, scope_d_));
-        cout << "scope-B: created query: \"" << q << "\"" << endl;
-        return query;
-    }
-
-private:
-    string scope_name_;
-    ScopeProxy scope_c_;
-    ScopeProxy scope_d_;
-};
-
-extern "C"
-{
-
-    EXPORT
-    unity::api::scopes::ScopeBase*
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_CREATE_FUNCTION()
-    {
-        return new MyScope;
-    }
-
-    EXPORT
-    void
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
-    {
-        delete scope_base;
-    }
-
-}

=== removed file 'demo/scope-C.cpp'
--- demo/scope-C.cpp	2013-11-14 10:18:32 +0000
+++ demo/scope-C.cpp	1970-01-01 00:00:00 +0000
@@ -1,236 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/ScopeBase.h>
-#include <scopes/ResultItem.h>
-#include <scopes/Category.h>
-#include <scopes/Reply.h>
-
-#include <algorithm>
-#include <condition_variable>
-#include <iostream>
-#include <list>
-#include <mutex>
-#include <unistd.h>
-
-#define EXPORT __attribute__ ((visibility ("default")))
-
-using namespace std;
-using namespace unity::api::scopes;
-
-// Simple queue that stores query-string/reply pairs, using MyQuery* as a key for removal.
-// The put() method adds a pair at the tail, and the get() method returns a pair at the head.
-// get() suspends the caller until an item is available or until the queue is told to finish.
-// get() returns true if it returns a pair, false if the queue was told to finish.
-// remove() searches for the entry with the given key and erases it.
-
-class MyQuery;
-
-class Queue
-{
-public:
-    void put(MyQuery const* query, string const& query_string, ReplyProxy const& reply_proxy)
-    {
-        std::lock_guard<std::mutex> lock(mutex_);
-        queries_.push_back(QueryData { query, query_string, reply_proxy });
-        condvar_.notify_one();
-    }
-
-    bool get(string& query_string, ReplyProxy& reply_proxy)
-    {
-        std::unique_lock<std::mutex> lock(mutex_);
-        condvar_.wait(lock, [this] { return !queries_.empty() || done_; });
-        if (done_)
-        {
-            condvar_.notify_all();
-        }
-        else
-        {
-            auto qd = queries_.front();
-            queries_.pop_front();
-            query_string = qd.query_string;
-            reply_proxy = qd.reply_proxy;
-        }
-        return !done_;
-    }
-
-    void remove(MyQuery const* query)
-    {
-        std::lock_guard<std::mutex> lock(mutex_);
-        QueryData qd { query, "", nullptr };
-        auto it = std::find(queries_.begin(), queries_.end(), qd);
-        if (it != queries_.end())
-        {
-            cerr << "Queue: removed query: " << it->query_string << endl;
-            queries_.erase(it);
-        }
-        else
-        {
-            cerr << "Queue: did not find entry to be removed" << endl;
-        }
-    }
-
-    void finish()
-    {
-        std::unique_lock<std::mutex> lock(mutex_);
-        queries_.clear();
-        done_ = true;
-        condvar_.notify_all();
-    }
-
-    Queue()
-        : done_(false)
-    {
-    }
-
-private:
-    struct QueryData
-    {
-        MyQuery const* query;
-        string query_string;
-        ReplyProxy reply_proxy;
-
-        bool operator==(QueryData const& rhs) const
-        {
-            return query == rhs.query;
-        }
-    };
-
-    std::list<QueryData> queries_;
-    bool done_;
-    std::mutex mutex_;
-    std::condition_variable condvar_;
-};
-
-// Example scope C: Does not use the query's run() method other than to remember the query.
-// The run() method of the scope acts as a worker thread to push replies to remembered queries.
-// This example shows that letting run() return immediately is OK, and that the MyQuery instance stays
-// alive as long as it can still be cancelled, which is while there is at least one
-// ReplyProxy still in existence for this query.
-
-class MyQuery : public QueryBase
-{
-public:
-    MyQuery(string const& query, Queue& queue) :
-        query_(query),
-        queue_(queue)
-    {
-        cerr << "My Query created" << endl;
-    }
-
-    ~MyQuery() noexcept
-    {
-        cerr << "My Query destroyed" << endl;
-    }
-
-    virtual void cancelled() override
-    {
-        // Remove this query from the queue, if it is still there.
-        // If it isn't, and the worker thread is still working on this
-        // query, the worker thread's next call to push() will return false,
-        // causing the worker thread to stop working on this query.
-        queue_.remove(this);
-        cerr << "scope-C: \"" + query_ + "\" cancelled" << endl;
-    }
-
-    virtual void run(ReplyProxy const& reply) override
-    {
-        queue_.put(this, query_, reply);
-        cerr << "scope-C: run() returning" << endl;
-    }
-
-private:
-    string query_;
-    Queue& queue_;
-};
-
-class MyScope : public ScopeBase
-{
-public:
-    virtual int start(string const& scope_name, RegistryProxy const&) override
-    {
-        scope_name_ = scope_name;
-        return VERSION;
-    }
-
-    virtual void stop() override
-    {
-        queue.finish();
-    }
-
-    virtual void run() override
-    {
-        for (;;)
-        {
-            string query;
-            ReplyProxy reply;
-            if (!queue.get(query, reply))
-            {
-                cerr << "worker thread terminating, queue was cleared" << endl;
-                break;  // stop() was called.
-            }
-            for (int i = 1; i < 4; ++i)
-            {
-                cerr << "worker thread: pushing" << endl;
-                auto cat = std::make_shared<Category>("cat1");
-                ResultItem result(cat);
-                result.set_uri("uri");
-                result.set_title("scope-C: result " + to_string(i) + " for query \"" + query + "\"");
-                result.set_icon("icon");
-                result.set_dnd_uri("dnd_uri");
-                if (!reply->push(result))
-                {
-                    cerr << "worker thread: push returned false" << endl;
-                    break; // Query was cancelled
-                }
-                sleep(1);
-            }
-        }
-    }
-
-    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
-    {
-        cout << scope_name_ << ": created query: \"" << q << "\"" << endl;
-        return QueryBase::UPtr(new MyQuery(q, queue));
-    }
-
-private:
-    string scope_name_;
-    Queue queue;
-};
-
-extern "C"
-{
-
-    EXPORT
-    unity::api::scopes::ScopeBase*
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_CREATE_FUNCTION()
-    {
-        return new MyScope;
-    }
-
-    EXPORT
-    void
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
-    {
-        delete scope_base;
-    }
-
-}

=== removed file 'demo/scope-D.cpp'
--- demo/scope-D.cpp	2013-11-14 10:18:32 +0000
+++ demo/scope-D.cpp	1970-01-01 00:00:00 +0000
@@ -1,261 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/RegistryProxyFwd.h>
-#include <scopes/Reply.h>
-#include <scopes/Category.h>
-#include <scopes/ResultItem.h>
-#include <scopes/ScopeBase.h>
-
-#include <algorithm>
-#include <atomic>
-#include <condition_variable>
-#include <iostream>
-#include <list>
-#include <mutex>
-
-#include <unistd.h>
-
-#define EXPORT __attribute__ ((visibility ("default")))
-
-using namespace std;
-using namespace unity::api::scopes;
-
-// Simple queue that stores query-string/reply pairs, using MyQuery* as a key for removal.
-// The put() method adds a pair at the tail, and the get() method returns a pair at the head.
-// get() suspends the caller until an item is available or until the queue is told to finish.
-// get() returns true if it returns a pair, false if the queue was told to finish.
-// remove() searches for the entry with the given key and erases it.
-
-class MyQuery;
-
-class Queue
-{
-public:
-    void put(MyQuery const* query, string const& query_string, ReplyProxy const& reply_proxy)
-    {
-        std::lock_guard<std::mutex> lock(mutex_);
-        queries_.push_back(QueryData { query, query_string, reply_proxy });
-        condvar_.notify_one();
-    }
-
-    bool get(string& query_string, ReplyProxy& reply_proxy)
-    {
-        std::unique_lock<std::mutex> lock(mutex_);
-        condvar_.wait(lock, [this] { return !queries_.empty() || done_; });
-        if (done_)
-        {
-            condvar_.notify_all();
-        }
-        else
-        {
-            auto qd = queries_.front();
-            queries_.pop_front();
-            query_string = qd.query_string;
-            reply_proxy = qd.reply_proxy;
-        }
-        return !done_;
-    }
-
-    void remove(MyQuery const* query)
-    {
-        std::lock_guard<std::mutex> lock(mutex_);
-        QueryData qd { query, "", nullptr };
-        auto it = std::find(queries_.begin(), queries_.end(), qd);
-        if (it != queries_.end())
-        {
-            cerr << "Queue: removed query: " << it->query_string << endl;
-            queries_.erase(it);
-        }
-        else
-        {
-            cerr << "Queue: did not find entry to be removed" << endl;
-        }
-    }
-
-    void finish()
-    {
-        std::unique_lock<std::mutex> lock(mutex_);
-        queries_.clear();
-        done_ = true;
-        condvar_.notify_all();
-    }
-
-    Queue()
-        : done_(false)
-    {
-    }
-
-private:
-    struct QueryData
-    {
-        MyQuery const* query;
-        string query_string;
-        ReplyProxy reply_proxy;
-
-        bool operator==(QueryData const& rhs) const
-        {
-            return query == rhs.query;
-        }
-    };
-
-    std::list<QueryData> queries_;
-    bool done_;
-    std::mutex mutex_;
-    std::condition_variable condvar_;
-};
-
-class MyQuery : public QueryBase
-{
-public:
-    MyQuery(string const& scope_name,
-            string const& query,
-            Queue& queue) :
-        scope_name_(scope_name),
-        query_(query),
-        queue_(queue)
-    {
-        cerr << "query instance for \"" << scope_name_ << ":" << query << "\" created" << endl;
-    }
-
-    virtual ~MyQuery() noexcept
-    {
-        cerr << "query instance for \"" << scope_name_ << ":" << query_ << "\" destroyed" << endl;
-    }
-
-    virtual void cancelled() override
-    {
-        // Informational callback to let a query know when it was cancelled. The query should
-        // clean up any resources it has allocated, stop pushing results, and arrange for
-        // run() to return (if still active).
-        // Ignoring query cancelltion does not do any direct harm, but wastes CPU cycles: any
-        // results that are pushed once a query is cancelled are ignored anyway.
-        // The main purpose of this callback to give queries a chance to stop doing whatever
-        // work may still be in progress on a query. Note that cancellations are frequent;
-        // not responding to cancelled() correctly causes loss of performance.
-
-        cerr << "query for \"" << scope_name_ << ":" << query_ << "\" cancelled" << endl;
-    }
-
-    virtual void run(ReplyProxy const& reply) override
-    {
-        // The query can do anything it likes with this method, that is, run() can push results
-        // directly on the provided reply, or it can save the reply for later use and return from
-        // run(). It is OK to push results on the reply from a different thread.
-        // The only obligation on run() is that, if cancelled() is called, and run() is still active
-        // at that time, run() must tidy up and return in a timely fashion.
-        queue_.put(this, query_, reply);
-    }
-
-private:
-    string scope_name_;
-    string query_;
-    Queue& queue_;
-};
-
-// Example scope D: replies asynchronously to queries.
-// The scope's run() method is used as a worker thread that pulls queries from a queue.
-// The MyQuery object's run() method adds the query string and the reply proxy to the queue
-// and signals the worker thread, and then returns. The worker thread pushes the results.
-
-class MyScope : public ScopeBase
-{
-public:
-    virtual int start(string const& scope_name, RegistryProxy const&) override
-    {
-        scope_name_ = scope_name;
-        return VERSION;
-    }
-
-    virtual void stop() override
-    {
-        queue_.finish();
-        done_.store(true);
-    }
-
-    virtual void run() override
-    {
-        // What run() does is up to the scope. For example, we could set up and run an event loop here.
-        // It's OK for run() to be empty and return immediately, or to take as long it likes to complete.
-        // The only obligation is that, if the scopes run time calls stop(), run() must tidy up and return
-        // in as timely a manner as possible.
-        while (!done_.load())
-        {
-            string query;
-            ReplyProxy reply_proxy;
-            if (queue_.get(query, reply_proxy) && !done_.load())
-            {
-                for (int i = 1; i < 5; ++i)
-                {
-                    auto cat = std::make_shared<Category>("cat1");
-                    ResultItem result(cat);
-                    result.set_uri("uri");
-                    result.set_title(scope_name_ + ": result " + to_string(i) + " for query \"" + query + "\"");
-                    result.set_icon("icon");
-                    result.set_dnd_uri("dnd_uri");
-                    if (!reply_proxy->push(result))
-                    {
-                        break; // Query was cancelled
-                    }
-                    sleep(1);
-                }
-                cerr << scope_name_ << ": query \"" << query << "\" complete" << endl;
-            }
-        }
-    }
-
-    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
-    {
-        QueryBase::UPtr query(new MyQuery(scope_name_, q, queue_));
-        cerr << scope_name_ << ": created query: \"" << q << "\"" << endl;
-        return query;
-    }
-
-    MyScope()
-        : done_(false)
-    {
-    }
-
-private:
-    string scope_name_;
-    Queue queue_;
-    std::atomic_bool done_;
-};
-
-// External entry points to allocate and deallocate the scope.
-
-extern "C"
-{
-
-    EXPORT
-    unity::api::scopes::ScopeBase*
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_CREATE_FUNCTION()
-    {
-        return new MyScope;
-    }
-
-    EXPORT
-    void
-    // cppcheck-suppress unusedFunction
-    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
-    {
-        delete scope_base;
-    }
-
-}

=== added directory 'demo/scope-groups'
=== added file 'demo/scope-groups/CMakeLists.txt'
--- demo/scope-groups/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scope-groups/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+configure_file(GroupBC.ini.in GroupBC.ini)

=== added file 'demo/scope-groups/GroupBC.ini.in'
--- demo/scope-groups/GroupBC.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scope-groups/GroupBC.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,2 @@
+[ScopeGroup]
+Scopes = scope-B;scope-C

=== removed file 'demo/scoperunner-A.cpp'
--- demo/scoperunner-A.cpp	2013-11-01 12:44:48 +0000
+++ demo/scoperunner-A.cpp	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/internal/RuntimeImpl.h>
-#include <scopes/internal/ScopeLoader.h>
-#include <scopes/internal/ScopeObject.h>
-#include <unity/UnityExceptions.h>
-
-#include <iostream>
-
-using namespace std;
-using namespace unity::api::scopes;
-using namespace unity::api::scopes::internal;
-
-int
-main(int, char**)
-{
-    // TODO: the hard-wired strings here need to be read from config.
-
-    string scope_name = string("scope-A");
-
-    try
-    {
-        RuntimeImpl::UPtr rt = RuntimeImpl::create(scope_name);
-        ScopeLoader::SPtr loader = ScopeLoader::load(scope_name, "lib" + scope_name + ".so", rt->registry());
-        loader->start();
-        MiddlewareBase::SPtr mw = rt->factory()->create(scope_name, "Zmq", "Zmq.Config");
-        ScopeObject::SPtr scope(new ScopeObject(rt.get(), loader->scope_base()));
-        mw->add_scope_object(scope_name, scope);
-        mw->wait_for_shutdown();
-    }
-    catch (unity::Exception const& e)
-    {
-        cerr << e.to_string() << endl;
-        return 1;
-    }
-
-    return 0;
-}

=== removed file 'demo/scoperunner-BC.cpp'
--- demo/scoperunner-BC.cpp	2013-11-01 12:44:48 +0000
+++ demo/scoperunner-BC.cpp	1970-01-01 00:00:00 +0000
@@ -1,67 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/internal/RuntimeImpl.h>
-#include <scopes/internal/ScopeLoader.h>
-#include <scopes/internal/ScopeObject.h>
-#include <unity/UnityExceptions.h>
-
-#include <iostream>
-
-using namespace std;
-using namespace unity::api::scopes;
-using namespace unity::api::scopes::internal;
-
-int
-main(int, char**)
-{
-    // TODO: the hard-wired strings here need to be read from config.
-
-    string scope_nameB = string("scope-B");
-    string scope_nameC = string("scope-C");
-
-    try
-    {
-        RuntimeImpl::UPtr rtB = RuntimeImpl::create(scope_nameB);
-        MiddlewareBase::SPtr mwB = rtB->factory()->create(rtB->scope_name(), "Zmq", "Zmq.Config");
-        ScopeLoader::SPtr loaderB = ScopeLoader::load(rtB->scope_name(), "lib" + rtB->scope_name() + ".so",
-                                                      rtB->registry());
-        loaderB->start();
-        ScopeObject::SPtr scopeB(new ScopeObject(rtB.get(), loaderB->scope_base()));
-        mwB->add_scope_object(rtB->scope_name(), scopeB);
-
-        RuntimeImpl::UPtr rtC = RuntimeImpl::create(scope_nameC);
-        MiddlewareBase::SPtr mwC = rtC->factory()->create(rtC->scope_name(), "Zmq", "Zmq.Config");
-        ScopeLoader::SPtr loaderC = ScopeLoader::load(rtC->scope_name(), "lib" + rtC->scope_name() + ".so",
-                                                      rtC->registry());
-        loaderC->start();
-        ScopeObject::SPtr scopeC(new ScopeObject(rtC.get(), loaderC->scope_base()));
-        mwC->add_scope_object(rtC->scope_name(), scopeC);
-
-        mwB->wait_for_shutdown();
-        mwC->wait_for_shutdown();
-    }
-
-    catch (unity::Exception const& e)
-    {
-        cerr << e.to_string() << endl;
-        return 1;
-    }
-
-    return 0;
-}

=== removed file 'demo/scoperunner-D.cpp'
--- demo/scoperunner-D.cpp	2013-11-01 12:44:48 +0000
+++ demo/scoperunner-D.cpp	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/internal/RuntimeImpl.h>
-#include <scopes/internal/ScopeLoader.h>
-#include <scopes/internal/ScopeObject.h>
-#include <unity/UnityExceptions.h>
-
-#include <iostream>
-
-using namespace std;
-using namespace unity::api::scopes;
-using namespace unity::api::scopes::internal;
-
-int
-main(int, char**)
-{
-    // TODO: the hard-wired strings here need to be read from config.
-
-    string scope_name = string("scope-D");
-
-    try
-    {
-        RuntimeImpl::UPtr rt = RuntimeImpl::create(scope_name);
-        MiddlewareBase::SPtr mw = rt->factory()->create(rt->scope_name(), "Zmq", "Zmq.Config");
-        ScopeLoader::SPtr loader = ScopeLoader::load(rt->scope_name(), "lib" + rt->scope_name() + ".so", rt->registry());
-        loader->start();
-        ScopeObject::SPtr scope(new ScopeObject(rt.get(), loader->scope_base()));
-        mw->add_scope_object(rt->scope_name(), scope);
-        mw->wait_for_shutdown();
-    }
-    catch (unity::Exception const& e)
-    {
-        cerr << e.to_string() << endl;
-        return 1;
-    }
-
-    return 0;
-}

=== removed file 'demo/scoperunner-slow.cpp'
--- demo/scoperunner-slow.cpp	2013-11-01 12:44:48 +0000
+++ demo/scoperunner-slow.cpp	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/internal/RuntimeImpl.h>
-#include <scopes/internal/ScopeLoader.h>
-#include <scopes/internal/ScopeObject.h>
-#include <unity/UnityExceptions.h>
-
-#include <iostream>
-
-using namespace std;
-using namespace unity::api::scopes;
-using namespace unity::api::scopes::internal;
-
-int
-main(int, char**)
-{
-    // TODO: the hard-wired strings here need to be read from config.
-
-    string scope_name = string("scope-slow");
-
-    try
-    {
-        RuntimeImpl::UPtr x;
-        RuntimeImpl::UPtr rt = RuntimeImpl::create(scope_name);
-        ScopeLoader::SPtr loader = ScopeLoader::load(scope_name, "lib" + scope_name + ".so", rt->registry());
-        loader->start();
-        MiddlewareBase::SPtr mw = rt->factory()->create(scope_name, "Zmq", "Zmq.Config");
-        ScopeObject::SPtr scope(new ScopeObject(rt.get(), loader->scope_base()));
-        mw->add_scope_object(scope_name, scope);
-        mw->wait_for_shutdown();
-    }
-    catch (unity::Exception const& e)
-    {
-        cerr << e.to_string() << endl;
-        return 1;
-    }
-
-    return 0;
-}

=== added directory 'demo/scopes'
=== added file 'demo/scopes/CMakeLists.txt'
--- demo/scopes/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,6 @@
+add_subdirectory(scope-A)
+add_subdirectory(scope-B)
+add_subdirectory(scope-C)
+add_subdirectory(scope-D)
+add_subdirectory(scope-N)
+add_subdirectory(scope-S)

=== added directory 'demo/scopes/scope-A'
=== added file 'demo/scopes/scope-A/CMakeLists.txt'
--- demo/scopes/scope-A/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-A/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,3 @@
+add_library(scope-A MODULE scope-A.cpp)
+
+configure_file(scope-A.ini.in scope-A.ini)

=== added file 'demo/scopes/scope-A/scope-A.cpp'
--- demo/scopes/scope-A/scope-A.cpp	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-A/scope-A.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,103 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/ScopeBase.h>
+#include <scopes/Reply.h>
+#include <scopes/Category.h>
+#include <scopes/ResultItem.h>
+
+#include <iostream>
+
+#define EXPORT __attribute__ ((visibility ("default")))
+
+using namespace std;
+using namespace unity::api::scopes;
+
+// Example scope A: replies synchronously to a query. (Replies are returned before returning from the run() method.)
+
+class MyQuery : public QueryBase
+{
+public:
+    MyQuery(string const& query) :
+        query_(query)
+    {
+    }
+
+    ~MyQuery() noexcept
+    {
+    }
+
+    virtual void cancelled() override
+    {
+    }
+
+    virtual void run(ReplyProxy const& reply) override
+    {
+        auto cat = std::shared_ptr<Category>(new Category("cat1"));
+        ResultItem res(cat);
+        res.set_uri("uri");
+        res.set_title("scope-A: result 1 for query \"" + query_ + "\"");
+        res.set_icon("icon");
+        res.set_dnd_uri("dnd_uri");
+        reply->push(res);
+        cout << "scope-A: query \"" << query_ << "\" complete" << endl;
+    }
+
+private:
+    string query_;
+};
+
+class MyScope : public ScopeBase
+{
+public:
+    virtual int start(string const&, RegistryProxy const&) override
+    {
+        return VERSION;
+    }
+
+    virtual void stop() override {}
+    virtual void run() override {}
+
+    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
+    {
+        QueryBase::UPtr query(new MyQuery(q));
+        cout << "scope-A: created query: \"" << q << "\"" << endl;
+        return query;
+    }
+};
+
+extern "C"
+{
+
+    EXPORT
+    unity::api::scopes::ScopeBase*
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_CREATE_FUNCTION()
+    {
+        return new MyScope;
+    }
+
+    EXPORT
+    void
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
+    {
+        delete scope_base;
+    }
+
+}

=== added file 'demo/scopes/scope-A/scope-A.ini.in'
--- demo/scopes/scope-A/scope-A.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-A/scope-A.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+[ScopeConfig]

=== added directory 'demo/scopes/scope-B'
=== added file 'demo/scopes/scope-B/CMakeLists.txt'
--- demo/scopes/scope-B/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-B/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,3 @@
+add_library(scope-B MODULE scope-B.cpp)
+
+configure_file(scope-B.ini.in scope-B.ini)

=== added file 'demo/scopes/scope-B/scope-B.cpp'
--- demo/scopes/scope-B/scope-B.cpp	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-B/scope-B.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,147 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/Registry.h>
+#include <scopes/Reply.h>
+#include <scopes/ResultItem.h>
+#include <scopes/ScopeBase.h>
+#include <unity/UnityExceptions.h>
+
+#include <iostream>
+
+#define EXPORT __attribute__ ((visibility ("default")))
+
+using namespace std;
+using namespace unity::api::scopes;
+
+// Example scope B: aggregates from scope C and D.
+
+// A Reply instance remembers the query string and the reply object that was passed
+// from upstream. Results from the child scopes are sent to that upstream reply object.
+
+class SubReply : public ReplyBase
+{
+public:
+    virtual void push(ResultItem const& result) override
+    {
+        cout << "received result from " << scope_name_ << ": " << result.uri() << ", " << result.title() << endl;
+        upstream_->push(result);
+    }
+
+    virtual void finished() override
+    {
+        cout << "query to " << scope_name_ << " complete" << endl;
+    }
+
+    SubReply(string const& scope_name, ReplyProxy const& upstream) :
+        scope_name_(scope_name),
+        upstream_(upstream)
+    {
+    }
+
+private:
+    string scope_name_;
+    ReplyProxy upstream_;
+};
+
+class MyQuery : public QueryBase
+{
+public:
+    MyQuery(string const& scope_name,
+            string const& query,
+            ScopeProxy const& scope_c,
+            ScopeProxy const& scope_d) :
+        scope_name_(scope_name),
+        query_(query),
+        scope_c_(scope_c),
+        scope_d_(scope_d)
+    {
+    }
+
+    virtual void cancelled()
+    {
+        cout << "query to " << scope_name_ << " was cancelled" << endl;
+    }
+
+    virtual void run(ReplyProxy const& upstream_reply)
+    {
+        ReplyBase::SPtr reply(new SubReply(scope_name_, upstream_reply));
+        create_subquery(scope_c_, query_, VariantMap(), reply);
+        create_subquery(scope_d_, query_, VariantMap(), reply);
+    }
+
+private:
+    string scope_name_;
+    string query_;
+    ScopeProxy scope_c_;
+    ScopeProxy scope_d_;
+};
+
+// MyScope aggregates from C and D.
+
+class MyScope : public ScopeBase
+{
+public:
+    virtual int start(string const& scope_name, RegistryProxy const& registry) override
+    {
+        scope_name_ = scope_name;
+
+        // Lock up scopes C and D in the registry and remember their proxies.
+        scope_c_ = registry->find("scope-C");
+        scope_d_ = registry->find("scope-D");
+
+        return VERSION;
+    }
+
+    virtual void stop() override {}
+
+    virtual void run() override {}
+
+    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
+    {
+        QueryBase::UPtr query(new MyQuery(scope_name_, q, scope_c_, scope_d_));
+        cout << "scope-B: created query: \"" << q << "\"" << endl;
+        return query;
+    }
+
+private:
+    string scope_name_;
+    ScopeProxy scope_c_;
+    ScopeProxy scope_d_;
+};
+
+extern "C"
+{
+
+    EXPORT
+    unity::api::scopes::ScopeBase*
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_CREATE_FUNCTION()
+    {
+        return new MyScope;
+    }
+
+    EXPORT
+    void
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
+    {
+        delete scope_base;
+    }
+
+}

=== added file 'demo/scopes/scope-B/scope-B.ini.in'
--- demo/scopes/scope-B/scope-B.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-B/scope-B.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+[ScopeConfig]

=== added directory 'demo/scopes/scope-C'
=== added file 'demo/scopes/scope-C/CMakeLists.txt'
--- demo/scopes/scope-C/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-C/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,3 @@
+add_library(scope-C MODULE scope-C.cpp)
+
+configure_file(scope-C.ini.in scope-C.ini)

=== added file 'demo/scopes/scope-C/scope-C.cpp'
--- demo/scopes/scope-C/scope-C.cpp	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-C/scope-C.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,241 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/ScopeBase.h>
+#include <scopes/ResultItem.h>
+#include <scopes/Category.h>
+#include <scopes/Reply.h>
+
+#include <algorithm>
+#include <condition_variable>
+#include <iostream>
+#include <list>
+#include <mutex>
+#include <unistd.h>
+
+#define EXPORT __attribute__ ((visibility ("default")))
+
+using namespace std;
+using namespace unity::api::scopes;
+
+// Simple queue that stores query-string/reply pairs, using MyQuery* as a key for removal.
+// The put() method adds a pair at the tail, and the get() method returns a pair at the head.
+// get() suspends the caller until an item is available or until the queue is told to finish.
+// get() returns true if it returns a pair, false if the queue was told to finish.
+// remove() searches for the entry with the given key and erases it.
+
+class MyQuery;
+
+class Queue
+{
+public:
+    void put(MyQuery const* query, string const& query_string, ReplyProxy const& reply_proxy)
+    {
+        {
+            std::lock_guard<std::mutex> lock(mutex_);
+            queries_.push_back(QueryData { query, query_string, reply_proxy });
+        }
+        condvar_.notify_one();
+    }
+
+    bool get(string& query_string, ReplyProxy& reply_proxy)
+    {
+        std::unique_lock<std::mutex> lock(mutex_);
+        condvar_.wait(lock, [this] { return !queries_.empty() || done_; });
+        if (done_)
+        {
+            lock.unlock();
+            condvar_.notify_all();
+        }
+        else
+        {
+            auto qd = queries_.front();
+            queries_.pop_front();
+            query_string = qd.query_string;
+            reply_proxy = qd.reply_proxy;
+        }
+        return !done_;
+    }
+
+    void remove(MyQuery const* query)
+    {
+        std::lock_guard<std::mutex> lock(mutex_);
+        QueryData qd { query, "", nullptr };
+        auto it = std::find(queries_.begin(), queries_.end(), qd);
+        if (it != queries_.end())
+        {
+            cerr << "Queue: removed query: " << it->query_string << endl;
+            queries_.erase(it);
+        }
+        else
+        {
+            cerr << "Queue: did not find entry to be removed" << endl;
+        }
+    }
+
+    void finish()
+    {
+        {
+            std::unique_lock<std::mutex> lock(mutex_);
+            queries_.clear();
+            done_ = true;
+        }
+        condvar_.notify_all();
+    }
+
+    Queue()
+        : done_(false)
+    {
+    }
+
+private:
+    struct QueryData
+    {
+        MyQuery const* query;
+        string query_string;
+        ReplyProxy reply_proxy;
+
+        bool operator==(QueryData const& rhs) const
+        {
+            return query == rhs.query;
+        }
+    };
+
+    std::list<QueryData> queries_;
+    bool done_;
+    std::mutex mutex_;
+    std::condition_variable condvar_;
+};
+
+// Example scope C: Does not use the query's run() method other than to remember the query.
+// The run() method of the scope acts as a worker thread to push replies to remembered queries.
+// This example shows that letting run() return immediately is OK, and that the MyQuery instance stays
+// alive as long as it can still be cancelled, which is while there is at least one
+// ReplyProxy still in existence for this query.
+
+class MyQuery : public QueryBase
+{
+public:
+    MyQuery(string const& query, Queue& queue) :
+        query_(query),
+        queue_(queue)
+    {
+        cerr << "My Query created" << endl;
+    }
+
+    ~MyQuery() noexcept
+    {
+        cerr << "My Query destroyed" << endl;
+    }
+
+    virtual void cancelled() override
+    {
+        // Remove this query from the queue, if it is still there.
+        // If it isn't, and the worker thread is still working on this
+        // query, the worker thread's next call to push() will return false,
+        // causing the worker thread to stop working on this query.
+        queue_.remove(this);
+        cerr << "scope-C: \"" + query_ + "\" cancelled" << endl;
+    }
+
+    virtual void run(ReplyProxy const& reply) override
+    {
+        queue_.put(this, query_, reply);
+        cerr << "scope-C: run() returning" << endl;
+    }
+
+private:
+    string query_;
+    Queue& queue_;
+};
+
+class MyScope : public ScopeBase
+{
+public:
+    virtual int start(string const& scope_name, RegistryProxy const&) override
+    {
+        scope_name_ = scope_name;
+        return VERSION;
+    }
+
+    virtual void stop() override
+    {
+        queue.finish();
+    }
+
+    virtual void run() override
+    {
+        for (;;)
+        {
+            string query;
+            ReplyProxy reply;
+            if (!queue.get(query, reply))
+            {
+                cerr << "worker thread terminating, queue was cleared" << endl;
+                break;  // stop() was called.
+            }
+            for (int i = 1; i < 4; ++i)
+            {
+                cerr << "worker thread: pushing" << endl;
+                auto cat = std::make_shared<Category>("cat1");
+                ResultItem result(cat);
+                result.set_uri("uri");
+                result.set_title("scope-C: result " + to_string(i) + " for query \"" + query + "\"");
+                result.set_icon("icon");
+                result.set_dnd_uri("dnd_uri");
+                if (!reply->push(result))
+                {
+                    cerr << "worker thread: push returned false" << endl;
+                    break; // Query was cancelled
+                }
+                sleep(1);
+            }
+        }
+    }
+
+    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
+    {
+        cout << scope_name_ << ": created query: \"" << q << "\"" << endl;
+        return QueryBase::UPtr(new MyQuery(q, queue));
+    }
+
+private:
+    string scope_name_;
+    Queue queue;
+};
+
+extern "C"
+{
+
+    EXPORT
+    unity::api::scopes::ScopeBase*
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_CREATE_FUNCTION()
+    {
+        return new MyScope;
+    }
+
+    EXPORT
+    void
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
+    {
+        delete scope_base;
+    }
+
+}

=== added file 'demo/scopes/scope-C/scope-C.ini.in'
--- demo/scopes/scope-C/scope-C.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-C/scope-C.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+[ScopeConfig]

=== added directory 'demo/scopes/scope-D'
=== added file 'demo/scopes/scope-D/CMakeLists.txt'
--- demo/scopes/scope-D/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-D/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,3 @@
+add_library(scope-D MODULE scope-D.cpp)
+
+configure_file(scope-D.ini.in scope-D.ini)

=== added file 'demo/scopes/scope-D/scope-D.cpp'
--- demo/scopes/scope-D/scope-D.cpp	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-D/scope-D.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,266 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/RegistryProxyFwd.h>
+#include <scopes/Reply.h>
+#include <scopes/Category.h>
+#include <scopes/ResultItem.h>
+#include <scopes/ScopeBase.h>
+
+#include <algorithm>
+#include <atomic>
+#include <condition_variable>
+#include <iostream>
+#include <list>
+#include <mutex>
+
+#include <unistd.h>
+
+#define EXPORT __attribute__ ((visibility ("default")))
+
+using namespace std;
+using namespace unity::api::scopes;
+
+// Simple queue that stores query-string/reply pairs, using MyQuery* as a key for removal.
+// The put() method adds a pair at the tail, and the get() method returns a pair at the head.
+// get() suspends the caller until an item is available or until the queue is told to finish.
+// get() returns true if it returns a pair, false if the queue was told to finish.
+// remove() searches for the entry with the given key and erases it.
+
+class MyQuery;
+
+class Queue
+{
+public:
+    void put(MyQuery const* query, string const& query_string, ReplyProxy const& reply_proxy)
+    {
+        {
+            std::lock_guard<std::mutex> lock(mutex_);
+            queries_.push_back(QueryData { query, query_string, reply_proxy });
+        }
+        condvar_.notify_one();
+    }
+
+    bool get(string& query_string, ReplyProxy& reply_proxy)
+    {
+        std::unique_lock<std::mutex> lock(mutex_);
+        condvar_.wait(lock, [this] { return !queries_.empty() || done_; });
+        if (done_)
+        {
+            lock.unlock();
+            condvar_.notify_all();
+        }
+        else
+        {
+            auto qd = queries_.front();
+            queries_.pop_front();
+            query_string = qd.query_string;
+            reply_proxy = qd.reply_proxy;
+        }
+        return !done_;
+    }
+
+    void remove(MyQuery const* query)
+    {
+        std::lock_guard<std::mutex> lock(mutex_);
+        QueryData qd { query, "", nullptr };
+        auto it = std::find(queries_.begin(), queries_.end(), qd);
+        if (it != queries_.end())
+        {
+            cerr << "Queue: removed query: " << it->query_string << endl;
+            queries_.erase(it);
+        }
+        else
+        {
+            cerr << "Queue: did not find entry to be removed" << endl;
+        }
+    }
+
+    void finish()
+    {
+        {
+            std::unique_lock<std::mutex> lock(mutex_);
+            queries_.clear();
+            done_ = true;
+        }
+        condvar_.notify_all();
+    }
+
+    Queue()
+        : done_(false)
+    {
+    }
+
+private:
+    struct QueryData
+    {
+        MyQuery const* query;
+        string query_string;
+        ReplyProxy reply_proxy;
+
+        bool operator==(QueryData const& rhs) const
+        {
+            return query == rhs.query;
+        }
+    };
+
+    std::list<QueryData> queries_;
+    bool done_;
+    std::mutex mutex_;
+    std::condition_variable condvar_;
+};
+
+class MyQuery : public QueryBase
+{
+public:
+    MyQuery(string const& scope_name,
+            string const& query,
+            Queue& queue) :
+        scope_name_(scope_name),
+        query_(query),
+        queue_(queue)
+    {
+        cerr << "query instance for \"" << scope_name_ << ":" << query << "\" created" << endl;
+    }
+
+    virtual ~MyQuery() noexcept
+    {
+        cerr << "query instance for \"" << scope_name_ << ":" << query_ << "\" destroyed" << endl;
+    }
+
+    virtual void cancelled() override
+    {
+        // Informational callback to let a query know when it was cancelled. The query should
+        // clean up any resources it has allocated, stop pushing results, and arrange for
+        // run() to return (if still active).
+        // Ignoring query cancelltion does not do any direct harm, but wastes CPU cycles: any
+        // results that are pushed once a query is cancelled are ignored anyway.
+        // The main purpose of this callback to give queries a chance to stop doing whatever
+        // work may still be in progress on a query. Note that cancellations are frequent;
+        // not responding to cancelled() correctly causes loss of performance.
+
+        cerr << "query for \"" << scope_name_ << ":" << query_ << "\" cancelled" << endl;
+    }
+
+    virtual void run(ReplyProxy const& reply) override
+    {
+        // The query can do anything it likes with this method, that is, run() can push results
+        // directly on the provided reply, or it can save the reply for later use and return from
+        // run(). It is OK to push results on the reply from a different thread.
+        // The only obligation on run() is that, if cancelled() is called, and run() is still active
+        // at that time, run() must tidy up and return in a timely fashion.
+        queue_.put(this, query_, reply);
+    }
+
+private:
+    string scope_name_;
+    string query_;
+    Queue& queue_;
+};
+
+// Example scope D: replies asynchronously to queries.
+// The scope's run() method is used as a worker thread that pulls queries from a queue.
+// The MyQuery object's run() method adds the query string and the reply proxy to the queue
+// and signals the worker thread, and then returns. The worker thread pushes the results.
+
+class MyScope : public ScopeBase
+{
+public:
+    virtual int start(string const& scope_name, RegistryProxy const&) override
+    {
+        scope_name_ = scope_name;
+        return VERSION;
+    }
+
+    virtual void stop() override
+    {
+        queue_.finish();
+        done_.store(true);
+    }
+
+    virtual void run() override
+    {
+        // What run() does is up to the scope. For example, we could set up and run an event loop here.
+        // It's OK for run() to be empty and return immediately, or to take as long it likes to complete.
+        // The only obligation is that, if the scopes run time calls stop(), run() must tidy up and return
+        // in as timely a manner as possible.
+        while (!done_.load())
+        {
+            string query;
+            ReplyProxy reply_proxy;
+            if (queue_.get(query, reply_proxy) && !done_.load())
+            {
+                for (int i = 1; i < 5; ++i)
+                {
+                    auto cat = std::make_shared<Category>("cat1");
+                    ResultItem result(cat);
+                    result.set_uri("uri");
+                    result.set_title(scope_name_ + ": result " + to_string(i) + " for query \"" + query + "\"");
+                    result.set_icon("icon");
+                    result.set_dnd_uri("dnd_uri");
+                    if (!reply_proxy->push(result))
+                    {
+                        break; // Query was cancelled
+                    }
+                    sleep(1);
+                }
+                cerr << scope_name_ << ": query \"" << query << "\" complete" << endl;
+            }
+        }
+    }
+
+    virtual QueryBase::UPtr create_query(string const& q, VariantMap const&) override
+    {
+        QueryBase::UPtr query(new MyQuery(scope_name_, q, queue_));
+        cerr << scope_name_ << ": created query: \"" << q << "\"" << endl;
+        return query;
+    }
+
+    MyScope()
+        : done_(false)
+    {
+    }
+
+private:
+    string scope_name_;
+    Queue queue_;
+    std::atomic_bool done_;
+};
+
+// External entry points to allocate and deallocate the scope.
+
+extern "C"
+{
+
+    EXPORT
+    unity::api::scopes::ScopeBase*
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_CREATE_FUNCTION()
+    {
+        return new MyScope;
+    }
+
+    EXPORT
+    void
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
+    {
+        delete scope_base;
+    }
+
+}

=== added file 'demo/scopes/scope-D/scope-D.ini.in'
--- demo/scopes/scope-D/scope-D.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-D/scope-D.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+[ScopeConfig]

=== added directory 'demo/scopes/scope-N'
=== added file 'demo/scopes/scope-N/CMakeLists.txt'
--- demo/scopes/scope-N/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-N/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,3 @@
+add_library(scope-N MODULE scope-N.cpp)
+
+configure_file(scope-N.ini.in scope-N.ini)

=== added file 'demo/scopes/scope-N/scope-N.cpp'
--- demo/scopes/scope-N/scope-N.cpp	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-N/scope-N.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,92 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/ScopeBase.h>
+
+#include <iostream>
+#include <thread>
+
+#define EXPORT __attribute__ ((visibility ("default")))
+
+using namespace std;
+using namespace unity::api::scopes;
+
+// Simplest possible scope: does absolutely nothing other than to implement the pure virtuals
+// it inherits from its base classes. Despite this, the scope works correctly with a client.
+
+class MyQuery : public QueryBase
+{
+public:
+    MyQuery()
+    {
+    }
+
+    ~MyQuery() noexcept
+    {
+    }
+
+    virtual void cancelled() override
+    {
+        cerr << "scope-no-op: received cancel request" << endl;
+    }
+
+    virtual void run(ReplyProxy const&) override
+    {
+        cerr << "scope-no-op: received query" << endl;
+        this_thread::sleep_for(chrono::seconds(3));
+        cerr << "scope-no-op: query complete" << endl;
+    }
+};
+
+class MyScope : public ScopeBase
+{
+public:
+    virtual int start(string const&, RegistryProxy const&) override
+    {
+        return VERSION;
+    }
+
+    virtual void stop() override {}
+    virtual void run() override {}
+
+    virtual QueryBase::UPtr create_query(string const&, VariantMap const&) override
+    {
+        return QueryBase::UPtr(new MyQuery);
+    }
+};
+
+extern "C"
+{
+
+    EXPORT
+    unity::api::scopes::ScopeBase*
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_CREATE_FUNCTION()
+    {
+        return new MyScope;
+    }
+
+    EXPORT
+    void
+    // cppcheck-suppress unusedFunction
+    UNITY_API_SCOPE_DESTROY_FUNCTION(unity::api::scopes::ScopeBase* scope_base)
+    {
+        delete scope_base;
+    }
+
+}

=== added file 'demo/scopes/scope-N/scope-N.ini.in'
--- demo/scopes/scope-N/scope-N.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-N/scope-N.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+[ScopeConfig]

=== added directory 'demo/scopes/scope-S'
=== added file 'demo/scopes/scope-S/CMakeLists.txt'
--- demo/scopes/scope-S/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-S/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,3 @@
+add_library(scope-S MODULE scope-S.cpp)
+
+configure_file(scope-S.ini.in scope-S.ini)

=== renamed file 'demo/scope-slow.cpp' => 'demo/scopes/scope-S/scope-S.cpp'
=== added file 'demo/scopes/scope-S/scope-S.ini.in'
--- demo/scopes/scope-S/scope-S.ini.in	1970-01-01 00:00:00 +0000
+++ demo/scopes/scope-S/scope-S.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,1 @@
+[ScopeConfig]

=== modified file 'include/scopes/internal/MiddlewareBase.h'
--- include/scopes/internal/MiddlewareBase.h	2013-11-01 12:44:48 +0000
+++ include/scopes/internal/MiddlewareBase.h	2013-11-19 02:51:46 +0000
@@ -62,6 +62,7 @@
     virtual void wait_for_shutdown() = 0;
 
     virtual MWRegistryProxy create_registry_proxy(std::string const& identity, std::string const& endpoint) = 0;
+    virtual MWScopeProxy create_scope_proxy(std::string const& identity) = 0;
     virtual MWScopeProxy create_scope_proxy(std::string const& identity, std::string const& endpoint) = 0;
 
     virtual MWQueryCtrlProxy add_query_ctrl_object(QueryCtrlObject::SPtr const& ctrl) = 0;

=== modified file 'include/scopes/internal/MiddlewareFactoryConfig.h'
--- include/scopes/internal/MiddlewareFactoryConfig.h	2013-11-01 12:44:48 +0000
+++ include/scopes/internal/MiddlewareFactoryConfig.h	2013-11-19 02:51:46 +0000
@@ -41,11 +41,11 @@
     MiddlewareFactoryConfig(std::string const& configfile);
     ~MiddlewareFactoryConfig() noexcept;
 
-    std::string ice_configfile() const;
+    std::string zmq_configfile() const;
     std::string rest_configfile() const;
 
 private:
-    std::string ice_configfile_;
+    std::string zmq_configfile_;
     std::string rest_configfile_;
 };
 

=== modified file 'include/scopes/internal/RegistryConfig.h'
--- include/scopes/internal/RegistryConfig.h	2013-11-01 12:44:48 +0000
+++ include/scopes/internal/RegistryConfig.h	2013-11-19 02:51:46 +0000
@@ -43,14 +43,26 @@
 
     std::string identity() const;
     std::string mw_kind() const;
+    std::string endpointdir() const;
     std::string endpoint() const;
     std::string mw_configfile() const;
+    std::string scope_installdir() const;       // Directory for Canonical scopes
+    std::string scope_group_configdir() const;  // Directory for Canonical scope group config files (colloecated scopes)
+    std::string oem_installdir() const;         // Directory for OEM scope config files
+    std::string oem_group_configdir() const;    // Directory for OEM scope group config files (collocated scopes)
+    std::string scoperunner_path() const;       // Path to scoperunner binary
 
 private:
     std::string identity_;
     std::string mw_kind_;
+    std::string endpointdir_;
     std::string endpoint_;
     std::string mw_configfile_;
+    std::string scope_installdir_;
+    std::string scope_group_configdir_;
+    std::string oem_installdir_;
+    std::string oem_group_configdir_;
+    std::string scoperunner_path_;
 };
 
 } // namespace internal

=== modified file 'include/scopes/internal/RegistryObject.h'
--- include/scopes/internal/RegistryObject.h	2013-11-01 12:44:48 +0000
+++ include/scopes/internal/RegistryObject.h	2013-11-19 02:51:46 +0000
@@ -53,9 +53,8 @@
     typedef std::map<std::string, MWScopeProxy> MWScopeMap;
     MWScopeMap list();
 
-    // Local operations to modify the map
-    void add(std::string const& scope_name, MWScopeProxy const& scope);
-    void remove(std::string const& scope_name);
+    bool add(std::string const& scope_name, MWScopeProxy const& scope);
+    bool remove(std::string const& scope_name);
 
 private:
     mutable MWScopeMap scopes_;

=== modified file 'include/scopes/internal/RuntimeImpl.h'
--- include/scopes/internal/RuntimeImpl.h	2013-11-01 12:44:48 +0000
+++ include/scopes/internal/RuntimeImpl.h	2013-11-19 02:51:46 +0000
@@ -51,6 +51,8 @@
     RegistryProxy registry() const;
     std::string registry_configfile() const;
     std::string registry_identity() const;
+    std::string registry_endpointdir() const;
+    std::string registry_endpoint() const;
     Reaper::SPtr reply_reaper() const;
 
     ~RuntimeImpl() noexcept;
@@ -65,6 +67,8 @@
     mutable RegistryProxy registry_;
     mutable std::string registry_configfile_;
     mutable std::string registry_identity_;
+    mutable std::string registry_endpointdir_;
+    mutable std::string registry_endpoint_;
     mutable Reaper::SPtr reply_reaper_;
     mutable std::mutex mutex_;                          // For lazy initialization of reply_reaper_
 };

=== added file 'include/scopes/internal/ScopeConfig.h'
--- include/scopes/internal/ScopeConfig.h	1970-01-01 00:00:00 +0000
+++ include/scopes/internal/ScopeConfig.h	2013-11-19 02:51:46 +0000
@@ -0,0 +1,58 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#ifndef UNITY_API_SCOPES_INTERNAL_SCOPECONFIG_H
+#define UNITY_API_SCOPES_INTERNAL_SCOPECONFIG_H
+
+#include <scopes/internal/ConfigBase.h>
+
+namespace unity
+{
+
+namespace api
+{
+
+namespace scopes
+{
+
+namespace internal
+{
+
+class ScopeConfig : public ConfigBase
+{
+public:
+    static constexpr const char* SCOPE_CONFIG_GROUP = "ScopeConfig";
+
+    ScopeConfig(std::string const& configfile);
+    ~ScopeConfig() noexcept;
+
+    bool overrideable() const;
+
+private:
+    bool overrideable_;
+};
+
+} // namespace internal
+
+} // namespace scopes
+
+} // namespace api
+
+} // namespace unity
+
+#endif

=== modified file 'include/scopes/internal/lttng/SimpleTracepoint.h'
--- include/scopes/internal/lttng/SimpleTracepoint.h	2013-11-18 23:41:30 +0000
+++ include/scopes/internal/lttng/SimpleTracepoint.h	2013-11-19 02:51:46 +0000
@@ -33,7 +33,7 @@
  */
 
 #ifdef __clang__
-// template< typename... T > void simple_tracepoint_unused_args( T&&... ) {}
+/* template< typename... T > void simple_tracepoint_unused_args( T&&... ) {} */
 #define simple_tracepoint( c, e, ... ) simple_tracepoint_unused_args( __VA_ARGS__ )
 #pragma message "Building with clang: Disabling LTTng tracepoints."
 #else

=== added file 'include/scopes/internal/zmq_middleware/ZmqConfig.h'
--- include/scopes/internal/zmq_middleware/ZmqConfig.h	1970-01-01 00:00:00 +0000
+++ include/scopes/internal/zmq_middleware/ZmqConfig.h	2013-11-19 02:51:46 +0000
@@ -0,0 +1,63 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#ifndef UNITY_API_SCOPES_INTERNAL_ZMQCONFIG_H
+#define UNITY_API_SCOPES_INTERNAL_ZMQCONFIG_H
+
+#include <scopes/internal/ConfigBase.h>
+
+#include <mutex>
+
+namespace unity
+{
+
+namespace api
+{
+
+namespace scopes
+{
+
+namespace internal
+{
+
+class ZmqConfig : public ConfigBase
+{
+public:
+    static const char* ZMQ_CONFIG_GROUP;
+
+    ZmqConfig(std::string const& configfile);
+    ~ZmqConfig() noexcept;
+
+    std::string public_dir() const;
+    std::string private_dir() const;
+
+private:
+    std::string public_dir_;
+    mutable std::string private_dir_;
+    mutable std::mutex mutex_;
+};
+
+} // namespace internal
+
+} // namespace scopes
+
+} // namespace api
+
+} // namespace unity
+
+#endif

=== modified file 'include/scopes/internal/zmq_middleware/ZmqMiddleware.h'
--- include/scopes/internal/zmq_middleware/ZmqMiddleware.h	2013-11-01 12:44:48 +0000
+++ include/scopes/internal/zmq_middleware/ZmqMiddleware.h	2013-11-19 02:51:46 +0000
@@ -24,6 +24,7 @@
 #include <scopes/internal/MWReplyProxyFwd.h>
 #include <scopes/internal/ThreadPool.h>
 #include <scopes/internal/UniqueID.h>
+#include <scopes/internal/zmq_middleware/ZmqConfig.h>
 #include <scopes/internal/zmq_middleware/ZmqObjectProxyFwd.h>
 
 #include <zmqpp/context.hpp>
@@ -61,6 +62,7 @@
     virtual void wait_for_shutdown() override;
 
     virtual MWRegistryProxy create_registry_proxy(std::string const& identity, std::string const& endpoint) override;
+    virtual MWScopeProxy create_scope_proxy(std::string const& identity) override;
     virtual MWScopeProxy create_scope_proxy(std::string const& identity, std::string const& endpoint) override;
 
     virtual MWQueryCtrlProxy add_query_ctrl_object(QueryCtrlObject::SPtr const& ctrl) override;
@@ -73,7 +75,7 @@
     ThreadPool* invoke_pool() const noexcept;
 
 private:
-    std::shared_ptr<ObjectAdapter> find_adapter(std::string const& name);
+    std::shared_ptr<ObjectAdapter> find_adapter(std::string const& name, std::string const& endpoint_dir);
 
     ZmqProxy safe_add(std::function<void()>& disconnect_func,
                       std::shared_ptr<ObjectAdapter> const& adapter,
@@ -93,6 +95,8 @@
     enum State { Stopped, Starting, Started };
     State state_;
     std::condition_variable state_changed_;
+
+    ZmqConfig config_;
 };
 
 } // namespace zmq_middleware

=== added directory 'scoperegistry'
=== added file 'scoperegistry/CMakeLists.txt'
--- scoperegistry/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ scoperegistry/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,10 @@
+set(SRC
+        FindFiles.cpp
+        scoperegistry.cpp
+        SignalThread.cpp
+)
+
+include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+
+add_executable(scoperegistry ${SRC})
+target_link_libraries(scoperegistry ${UNITY_SCOPES_LIB} ${OTHER_LIBS})

=== added file 'scoperegistry/FindFiles.cpp'
--- scoperegistry/FindFiles.cpp	1970-01-01 00:00:00 +0000
+++ scoperegistry/FindFiles.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,138 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the Lesser GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * Lesser GNU General Public License for more details.
+ *
+ * You should have received a copy of the Lesser GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include "FindFiles.h"
+
+#include <unity/UnityExceptions.h>
+#include <unity/util/ResourcePtr.h>
+
+#include <dirent.h>
+#include <string.h>
+#include <sys/stat.h>
+
+using namespace std;
+using namespace unity;
+
+namespace scoperegistry
+{
+
+namespace
+{
+
+bool has_suffix(string const& s, string const& suffix)
+{
+    auto s_len = s.length();
+    auto suffix_len = suffix.length();
+    if (s_len >= suffix_len)
+    {
+        return s.compare(s_len - suffix_len, suffix_len, suffix) == 0;
+    }
+    return false;
+}
+
+// Return all paths underneath the given dir that are of the given type
+// or are a symbolic link.
+
+enum EntryType { File, Directory };
+
+vector<string> find_entries(string const& install_dir, EntryType type)
+{
+    DIR* d = opendir(install_dir.c_str());
+    if (d == NULL)
+    {
+        throw ResourceException("cannot open scope installation directory \"" + install_dir + "\": " + strerror(errno));
+    }
+    util::ResourcePtr<DIR*, decltype(&closedir)> dir_ptr(d, closedir);  // Clean up automatically
+
+    vector<string> entries;
+
+    struct dirent* entry;
+    while ((entry = readdir(dir_ptr.get())) != NULL)
+    {
+        string name = entry->d_name;
+        if (name == "." || name == "..")
+        {
+            continue;   // Ignore current and parent dir
+        }
+        struct stat st;
+        int rc = lstat((install_dir + "/" + name).c_str(), &st);
+        if (rc == -1)
+        {
+            continue;   // We ignore errors, such as a file having been unlinked in the mean time.
+        }
+        if (type == File && !S_ISREG(st.st_mode) && !S_ISLNK(st.st_mode))
+        {
+            continue;   // Not a regular file or symbolic link
+        }
+        else if (type == Directory && !S_ISDIR(st.st_mode) && !S_ISLNK(st.st_mode))
+        {
+            continue;   // Not a directory or symbolic link
+        }
+        entries.emplace_back(install_dir + "/" + name);
+    }
+
+    return entries;
+}
+
+} // namespace
+
+// Return all files of the form dir/<somescope>/<scomescope>.ini that are regular files or
+// symbolic links and have the specified suffix.
+// The empty suffix is legal and causes all regular files and symlinks to be returned.
+
+vector<string> find_scope_config_files(string const& install_dir, string const& suffix)
+{
+    vector<string> files;
+
+    auto subdirs = find_entries(install_dir, Directory);
+    for (auto subdir : subdirs)
+    {
+        string scope_name = basename(const_cast<char*>(subdir.c_str()));    // basename() modifies its argument
+        auto candidates = find_entries(subdir, File);
+        for (auto c : candidates)
+        {
+            string config_name = basename(const_cast<char*>(c.c_str()));    // basename() modifies its argument
+            if (config_name == scope_name + suffix)
+            {
+                files.emplace_back(c);
+            }
+        }
+    }
+
+    return files;
+}
+
+// Return all files with the given suffix in dir.
+
+vector<string> find_files(string const& dir, string const& suffix)
+{
+    vector<string> files;
+
+    auto candidates = find_entries(dir, File);
+    for (auto c : candidates)
+    {
+        if (has_suffix(c, suffix))
+        {
+            files.emplace_back(c);
+        }
+    }
+
+    return files;
+}
+
+} // namespace scoperegistry

=== added file 'scoperegistry/FindFiles.h'
--- scoperegistry/FindFiles.h	1970-01-01 00:00:00 +0000
+++ scoperegistry/FindFiles.h	2013-11-19 02:51:46 +0000
@@ -0,0 +1,45 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#ifndef SCOPEREGISTRY_FINDFILES_H
+#define SCOPEREGISTRY_FINDFILES_H
+
+#include <vector>
+#include <string>
+
+namespace scoperegistry
+{
+
+// Return a vector of file names underneath a scope root install dir that have the given suffix.
+// Files are searched for exactly "one level down", that is, if we have a directory structure.
+//
+// canonical/scopeA/myconfig.ini
+// canonical/someScope/someScope.ini
+//
+// we get those two .ini files, but no .ini files in canonical or underneath
+// further-nested directories.
+
+std::vector<std::string> find_scope_config_files(std::string const& install_dir, std::string const& suffix);
+
+// Return a vector of file names in dir with the given suffix.
+
+std::vector<std::string> find_files(std::string const& dir, std::string const& suffix);
+
+} // namespace scoperegistry
+
+#endif

=== added file 'scoperegistry/SignalThread.cpp'
--- scoperegistry/SignalThread.cpp	1970-01-01 00:00:00 +0000
+++ scoperegistry/SignalThread.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,197 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <SignalThread.h>
+
+#include <unity/UnityExceptions.h>
+
+#include <cassert>
+#include <iostream>
+
+#include <signal.h>
+#include <string.h>
+#include <sys/wait.h>
+#include <unistd.h>
+
+using namespace std;
+using namespace unity;
+
+namespace scoperegistry
+{
+
+SignalThread::SignalThread() :
+    done_(false)
+{
+    // Block signals in the caller, so they are delivered to the thread we are about to create.
+    sigemptyset(&sigs_);
+    sigaddset(&sigs_, SIGCHLD);
+    sigaddset(&sigs_, SIGINT);
+    sigaddset(&sigs_, SIGHUP);
+    sigaddset(&sigs_, SIGTERM);
+    sigaddset(&sigs_, SIGUSR1);
+    int err = pthread_sigmask(SIG_BLOCK, &sigs_, nullptr);
+    if (err != 0)
+    {
+        throw SyscallException("pthread_sigmask failed", err);
+    }
+
+    // Make ourselves a process group leader.
+    setpgid(0, 0);
+
+    // Run a signal handling thread that waits for any of the above signals.
+    handler_thread_ = thread([this]{ this->wait_for_sigs(); });
+}
+
+SignalThread::~SignalThread() noexcept
+{
+    {
+        lock_guard<mutex> lock(mutex_);
+        if (!done_)
+        {
+            kill(getpid(), SIGUSR1);
+        }
+    }
+    handler_thread_.join();
+}
+
+// Add the pid and supplied command line to the table of children.
+
+void SignalThread::add_child(pid_t pid, char const* argv[])
+{
+    lock_guard<mutex> lock(mutex_);
+    if (done_)
+    {
+        return; // We've been told to go away already
+    }
+    string args;
+    for (int i = 0; argv[i] != nullptr; ++i)
+    {
+        if (i != 0)
+        {
+            args.append(" ");
+        }
+        args.append(argv[i]);
+    }
+    children_[pid] = args;
+}
+
+// Unblock the signals we are handling. This allows the child to reset the signals
+// to their defaults before calling exec().
+
+void SignalThread::reset_sigs()
+{
+    int err = pthread_sigmask(SIG_UNBLOCK, &sigs_, nullptr);
+    if (err != 0)
+    {
+        throw SyscallException("pthread_sigmask failed", err);
+    }
+}
+
+// Wait for signals. For SIGCHLD, we check exit status and report if a child terminated abnormally.
+// The normal termination signals (SIGINT, SIGHUP, and SIGTERM) are sent to the children.
+// SIGUSR1 causes the thread to return without touching any of its children.
+
+void SignalThread::wait_for_sigs()
+{
+    int signo;
+    for (;;)
+    {
+        int err = sigwait(&sigs_, &signo);
+        if (err != 0)
+        {
+            cerr << "scoperegistry: sigwait failed: " << strerror(err) << endl;
+            _exit(1);
+        }
+        switch (signo)
+        {
+            case SIGCHLD:
+            {
+                for (;;)
+                {
+                    // Multiple children exiting can result in only a single SIGCHLD being received,
+                    // so we loop until there are no more exited children.
+                    int status;
+                    pid_t pid = waitpid(-1, &status, WNOHANG);
+                    if (pid == -1)
+                    {
+                        if (errno != ECHILD)
+                        {
+                            cerr << "scoperegistry: wait() failed: " << strerror(errno) << endl;
+                            _exit(1);
+                        }
+                        continue; // Ignore stray SIGCHLD signals
+                    }
+                    if (pid == 0)
+                    {
+                        break;  // No more exited children remain.
+                    }
+
+                    lock_guard<mutex> lock(mutex_);
+                    auto it = children_.find(pid);
+                    if (it == children_.end())
+                    {
+                        cerr << "scoperegistry: ignoring unexpected child termination, pid = " << pid << endl;
+                        continue;
+                    }
+                    if (WIFEXITED(status))
+                    {
+                        if (WEXITSTATUS(status) != 0)
+                        {
+                            cerr << "scoperegistry: process " << pid << " exited with status " << WEXITSTATUS(status)
+                                 << ", command line: " << it->second << endl;
+                        }
+                    }
+                    else
+                    {
+                        cerr << "scoperegistry: process " << pid << " terminated by signal " << WTERMSIG(status)
+                             << ", command line: " << it->second << endl;
+                    }
+                    children_.erase(it);
+                }
+                break;
+            }
+            case SIGINT:
+            case SIGHUP:
+            case SIGTERM:
+            {
+                // Send the signal to all the children.
+                lock_guard<mutex> lock(mutex_);
+                for (auto pair : children_)
+                {
+                    kill(pair.first, signo);
+                }
+                done_ = true;
+                // TODO: for now, until the callback is added, just exit
+                _exit(signo);
+                break;
+            }
+            case SIGUSR1:
+            {
+                cerr << "signal thread: Got SIGUSR1" << endl;
+                // TODO: should invoke a callback here that then can shut down the run time.
+                return; // Go away without doing anything to the children.
+            }
+            default:
+            {
+                assert(false);
+            }
+        }
+    }
+}
+
+} // namespace scoperegistry

=== added file 'scoperegistry/SignalThread.h'
--- scoperegistry/SignalThread.h	1970-01-01 00:00:00 +0000
+++ scoperegistry/SignalThread.h	2013-11-19 02:51:46 +0000
@@ -0,0 +1,54 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#ifndef SCOPEREGISTRY_SIGNAL_THREAD_H
+#define SCOPEREGISTRY_SIGNAL_THREAD_H
+
+#include <unity/util/NonCopyable.h>
+
+#include <unordered_map>
+#include <mutex>
+#include <thread>
+
+#include <sys/types.h>
+
+namespace scoperegistry
+{
+
+class SignalThread final : private unity::util::NonCopyable
+{
+public:
+    SignalThread();
+    ~SignalThread() noexcept;
+
+    void add_child(pid_t pid, char const* argv[]);
+    void reset_sigs();
+
+private:
+    void wait_for_sigs();
+
+    std::unordered_map<pid_t, std::string> children_;
+    std::mutex mutex_;
+    bool done_;
+    std::thread handler_thread_;
+    sigset_t sigs_;
+};
+
+} // namespace scoperegistry
+
+#endif

=== added file 'scoperegistry/scoperegistry.cpp'
--- scoperegistry/scoperegistry.cpp	1970-01-01 00:00:00 +0000
+++ scoperegistry/scoperegistry.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,344 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include "FindFiles.h"
+#include "SignalThread.h"
+
+#include <scopes/internal/MiddlewareFactory.h>
+#include <scopes/internal/RegistryConfig.h>
+#include <scopes/internal/RegistryObject.h>
+#include <scopes/internal/RuntimeConfig.h>
+#include <scopes/internal/RuntimeImpl.h>
+#include <scopes/internal/ScopeConfig.h>
+#include <unity/UnityExceptions.h>
+#include <unity/util/ResourcePtr.h>
+
+#include <algorithm>
+#include <cassert>
+#include <iostream>
+#include <map>
+#include <set>
+#include <libgen.h>
+#include <unistd.h>
+
+using namespace scoperegistry;
+using namespace std;
+using namespace unity;
+using namespace unity::api::scopes;
+using namespace unity::api::scopes::internal;
+using namespace unity::util;
+
+char const* prog_name;
+
+namespace
+{
+
+void error(string const& msg)
+{
+    assert(!msg.empty());
+    cerr << prog_name << ": " << msg << endl;
+}
+
+string strip_suffix(string const& s, string const& suffix)
+{
+    auto s_len = s.length();
+    auto suffix_len = suffix.length();
+    if (s_len >= suffix_len)
+    {
+        if (s.compare(s_len - suffix_len, suffix_len, suffix) == 0)
+        {
+            return string(s, 0, s_len - suffix_len);
+        }
+    }
+    return s;
+}
+
+// Scan group config dir for .ini files. Each file is assumed to define a single scope group, in a group with key "ScopeGroup".
+// The key "Scopes" in the group is expected to contain an array of scope names.
+// For each scope group, the returned vector contains a map with the scope and .ini file names for that group.
+// If a particular scope appears in more than one group file, the first file found determines which group the scope
+// belongs too. (Subsequent mentions of a scope already in a group print a warning.)
+// all_scopes must be the map of all scopes that were originally found in config dir.
+// For any scopes not in a group, the returned vector contains a map containing just that scope. In other words,
+// the returned vector contains as many maps as there will be scoperunner processes, with each map containing
+// the scope name(s) and scope config file(s) for a process.
+
+vector<map<string, string>> create_scope_groups(string const& group_dir, map<string, string> all_scopes)
+{
+    set<string> scopes_seen;                     // Names of scopes that are in a group so far
+    vector<map<string, string>> scope_groups;    // One map per scope group
+    if (!group_dir.empty())
+    {
+        auto group_files = find_files(group_dir, ".ini");
+        for (auto file : group_files)
+        {
+            IniParser::SPtr parser;
+            try
+            {
+                parser = make_shared<IniParser>(file.c_str());
+            }
+            catch (FileException const& e)
+            {
+                error(e.to_string() + ": scope group file ignored");
+                continue;
+            }
+
+            vector<string> scopes;
+            try
+            {
+                scopes = parser->get_string_array("ScopeGroup", "Scopes");
+            }
+            catch (LogicException const& e)
+            {
+                error("group file \"" + file + ": file ignored: " + e.to_string());
+                continue;
+            }
+
+            // For each scope name in the group, push an element onto the vector of scope groups, but only if we have
+            // not seen that scope name in an earlier group.
+            bool once = false;
+            for (auto scope : scopes)
+            {
+                if (scopes_seen.find(scope) != scopes_seen.end())
+                {
+                    error("ignoring scope \"" + scope + "\" in group file " + file + ": scope is already part of a group");
+                    continue;
+                }
+                auto it = all_scopes.find(scope);
+                if (it == all_scopes.end())
+                {
+                    error("ignoring scope \"" + scope + "\" in group file " + file + ": cannot find configuration for this scope");
+                    continue;
+                }
+                scopes_seen.insert(scope);
+                if (!once)
+                {
+                    once = true;
+                    scope_groups.push_back(map<string, string>());
+                }
+                scope_groups.rbegin()->insert(make_pair(scope, it->second));
+                all_scopes.erase(it);                // Any scope in a group is removed from all_scopes.
+            }
+        }
+    }
+
+    // Any scopes remaining in all_scopes at this point were not part of a group and therefore are in a map by themselves.
+    for (auto pair : all_scopes)
+    {
+        map<string, string> s;
+        s.insert(pair);
+        scope_groups.push_back(s);
+    }
+
+    return scope_groups;
+}
+
+void run_scopes(SignalThread& sigthread,
+                string const& scoperunner_path,
+                string const& config_file,
+                vector<map<string, string>> const& groups)
+{
+    // Cobble together an argv for each scope group so we can fork/exec the scope runner for the group.
+    for (auto group : groups)
+    {
+        unique_ptr<char const* []> argv(new char const*[groups.size() + 3]);    // Includes room for final NULL element.
+        argv[0] = scoperunner_path.c_str();
+        argv[1] = config_file.c_str();
+        int i = 2;
+        for (auto it = group.begin(); it != group.end(); ++it)
+        {
+            argv[i++] = it->second.c_str();
+        }
+        argv[i] = NULL;
+
+        // Fork/exec the scoperunner.
+        pid_t pid;
+        switch (pid = fork())
+        {
+            case -1:
+            {
+                throw SyscallException("cannot fork", errno);
+            }
+            case 0: // child
+            {
+                sigthread.reset_sigs(); // Need default signal mask in the new process
+                execv(argv[0], const_cast<char* const*>(argv.get()));
+                throw SyscallException("cannot exec " + scoperunner_path, errno);
+            }
+        }
+
+        // Parent
+        sigthread.add_child(pid, argv.get());
+    }
+}
+
+} // namespace
+
+int
+main(int argc, char* argv[])
+{
+    prog_name = basename(argv[0]);
+    if (argc != 2)
+    {
+        cerr << "usage: " << prog_name << " configfile" << endl;
+        return 2;
+    }
+    char const* const config_file = argv[1];
+
+    int exit_status = 0;
+
+    // Run a separate thread to deal with SIGCHLD. This allows us to report when a scope process exits abnormally.
+    SignalThread signal_thread;
+
+    try
+    {
+        RuntimeImpl::UPtr runtime = RuntimeImpl::create("Registry", config_file);
+
+        string identity = runtime->registry_identity();
+
+        // Collect the registry config data.
+
+        string mw_kind;
+        string mw_endpoint;
+        string mw_configfile;
+        string scope_installdir;
+        string scope_group_configdir;
+        string oem_installdir;
+        string oem_group_configdir;
+        string scoperunner_path;
+        {
+            RegistryConfig c(identity, runtime->registry_configfile());
+            mw_kind = c.mw_kind();
+            mw_endpoint = c.endpoint();
+            mw_configfile = c.mw_configfile();
+            scope_installdir = c.scope_installdir();
+            scope_group_configdir = c.scope_group_configdir();
+            oem_installdir = c.oem_installdir();
+            oem_group_configdir = c.oem_group_configdir();
+            scoperunner_path = c.scoperunner_path();
+        } // Release memory for config parser
+
+        // Look in scope_installdir for scope configuration files.
+        // Scopes that do not permit themselves to be overridden are collected in fixed_scopes.
+        // Scopes that can be overridden are collected in overrideable_scopes.
+        // Each set contains file names (including the ".ini" suffix).
+
+        map<string, string> fixed_scopes;           // Scopes that the OEM cannot override
+        map<string, string> overrideable_scopes;    // Scopes that the OEM can override
+
+        auto config_files = find_scope_config_files(scope_installdir, ".ini");
+        for (auto path : config_files)
+        {
+            string file_name = basename(const_cast<char*>(string(path).c_str()));    // basename() modifies its argument
+            string scope_name = strip_suffix(file_name, ".ini");
+            ScopeConfig config(path);
+            if (config.overrideable())
+            {
+                overrideable_scopes[scope_name] = path;
+            }
+            else
+            {
+                fixed_scopes[scope_name] = path;
+            }
+        }
+
+        map<string, string> oem_scopes;             // Additional scopes provided by the OEM (including overriding ones)
+        if (!oem_installdir.empty())
+        {
+            auto oem_paths = find_scope_config_files(oem_installdir, ".ini");
+            for (auto path : oem_paths)
+            {
+                string file_name = basename(const_cast<char*>(string(path).c_str()));    // basename() modifies its argument
+                string scope_name = strip_suffix(file_name, ".ini");
+                if (fixed_scopes.find(scope_name) == fixed_scopes.end())
+                {
+                    overrideable_scopes.erase(scope_name);                // Only keep scopes that are not overridden by OEM
+                    oem_scopes[scope_name] = path;
+                }
+                else
+                {
+                    error("ignoring non-overrideable scope config \"" + file_name + "\" in OEM directory " + oem_installdir);
+                }
+            }
+        }
+
+        // Combine fixed_scopes and overrideable scopes now.
+        // overrideable_scopes only contains scopes that were *not* overridden by the OEM.
+        map<string, string> all_scopes;
+        all_scopes.insert(overrideable_scopes.begin(), overrideable_scopes.end());
+        all_scopes.insert(fixed_scopes.begin(), fixed_scopes.end());
+
+        // Clear memory for original maps.
+        map<string, string>().swap(fixed_scopes);
+        map<string, string>().swap(overrideable_scopes);
+
+        // Create the set of scope groups for Canonical and OEM scopes.
+        auto canonical_groups = create_scope_groups(scope_group_configdir, all_scopes);
+        auto oem_groups = create_scope_groups(oem_group_configdir, all_scopes);
+
+        MiddlewareBase::SPtr middleware = runtime->factory()->create(identity, mw_kind, mw_configfile);
+
+        // Add the registry implementation to the middleware.
+        RegistryObject::SPtr registry(new RegistryObject);
+        middleware->add_registry_object(runtime->registry_identity(), registry);
+
+        // Add a proxy for each scope to the lookup table.
+        // We do this before starting any of the scopes, so aggregating scopes don't get a lookup failure if
+        // they look for another scope in the registry.
+        for (auto pair : all_scopes)
+        {
+            registry->add(pair.first, middleware->create_scope_proxy(pair.first));
+        }
+
+        // Start a scoperunner for each Canonical scope group and add the corresponding proxies to the registry
+        run_scopes(signal_thread, scoperunner_path, config_file, canonical_groups);
+
+        // Start a scoperunner for each OEM scope group and add the corresponding proxies to the registry
+        // TODO: run_scopes(signal_thread, scoperunner_path, config_file, oem_groups);
+
+        // Wait until we are done.
+        middleware->wait_for_shutdown();
+    }
+    catch (unity::Exception const& e)
+    {
+        error(e.to_string());
+        exit_status = 1;
+    }
+    catch (std::exception const& e)
+    {
+        error(e.what());
+        exit_status = 1;
+    }
+    catch (string const& e)
+    {
+        error("fatal error: " + e);
+        exit_status = 1;
+    }
+    catch (char const* e)
+    {
+        error(string("fatal error: ") + e);
+        exit_status = 1;
+    }
+    catch (...)
+    {
+        error("terminated due to unknown exception");
+        exit_status = 1;
+    }
+
+    return exit_status;
+}

=== added directory 'scoperunner'
=== added file 'scoperunner/CMakeLists.txt'
--- scoperunner/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ scoperunner/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -0,0 +1,4 @@
+set(SRC scoperunner.cpp)
+
+add_executable(scoperunner ${SRC})
+target_link_libraries(scoperunner ${UNITY_SCOPES_LIB} ${OTHER_LIBS})

=== added file 'scoperunner/scoperunner.cpp'
--- scoperunner/scoperunner.cpp	1970-01-01 00:00:00 +0000
+++ scoperunner/scoperunner.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,245 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/internal/RuntimeImpl.h>
+#include <scopes/internal/ScopeLoader.h>
+#include <scopes/internal/ThreadSafeQueue.h>
+#include <scopes/internal/MWRegistry.h>
+#include <scopes/ScopeExceptions.h>
+#include <unity/UnityExceptions.h>
+
+#include <cassert>
+#include <future>
+#include <iostream>
+#include <string>
+#include <unordered_map>
+#include <vector>
+
+#include <libgen.h>
+
+using namespace std;
+using namespace unity::api::scopes;
+using namespace unity::api::scopes::internal;
+
+namespace
+{
+
+char const* prog_name;
+
+void error(string const& msg)
+{
+    assert(!msg.empty());
+    cerr << prog_name << ": " << msg << endl;
+}
+
+bool has_suffix(string const& s, string const& suffix)
+{
+    auto s_len = s.length();
+    auto suffix_len = suffix.length();
+    if (s_len >= suffix_len)
+    {
+        return s.compare(s_len - suffix_len, suffix_len, suffix) == 0;
+    }
+    return false;
+}
+
+string strip_suffix(string const& s, string const& suffix)
+{
+    auto s_len = s.length();
+    auto suffix_len = suffix.length();
+    if (s_len >= suffix_len)
+    {
+        if (s.compare(s_len - suffix_len, suffix_len, suffix) == 0)
+        {
+            return string(s, 0, s_len - suffix_len);
+        }
+    }
+    return s;
+}
+
+// One thread for each scope, plus a future that the thread sets when it finishes.
+
+struct ThreadFuture
+{
+    thread t;
+    std::future<void> f;
+};
+
+// Each thread provides its own ID on a queue when it finishes. That allows us to
+// then locate the thread in the map. The promise is set by the thread so we can
+// find out what happened to it and join with it. Unfortunately, we have to jump
+// through these hoops because there is no way to wait on multiple futures in C++ 11.
+
+unordered_map<thread::id, ThreadFuture> threads;
+
+ThreadSafeQueue<thread::id> finished_threads;
+
+// Scope thread start function.
+
+void scope_thread(string const& runtime_config,
+                  string const& scope_name,
+                  string const& lib_dir,
+                  promise<void> finished_promise)
+{
+    try
+    {
+        // Instantiate the run time, create the middleware, load the scope from its
+        // shared library, and call the scope's start() method.
+        auto rt = RuntimeImpl::create(scope_name, runtime_config);
+        auto mw = rt->factory()->create(scope_name, "Zmq", "Zmq.Config"); // TODO: get middleware from config
+        ScopeLoader::SPtr loader = ScopeLoader::load(scope_name, lib_dir + "lib" + scope_name + ".so", rt->registry());
+        loader->start();
+
+        // Give a thread to the scope to do with as it likes. If the scope doesn't want to use it and
+        // immediately returns from run(), that's fine.
+        auto run_future = std::async(launch::async, [loader] { loader->scope_base()->run(); });
+
+        // Create a servant for the scope and register the servant.
+        auto scope = unique_ptr<ScopeObject>(new ScopeObject(rt.get(), loader->scope_base()));
+        auto proxy = mw->add_scope_object(scope_name, move(scope));
+
+        mw->wait_for_shutdown();
+
+        // Collect exit status from the run thread. If this throws, the ScopeLoader
+        // destructor will still call stop() on the scope.
+        run_future.get();
+
+        finished_promise.set_value();
+    }
+    catch (...)
+    {
+        finished_promise.set_exception(current_exception());
+    }
+
+    finished_threads.push(this_thread::get_id());
+}
+
+// Run each of the scopes in config_files in a separate thread and wait for each thread to finish.
+// Return the number of threads that did not terminate normally.
+
+int run_scopes(string const& runtime_config, vector<string> config_files)
+{
+    for (auto file : config_files)
+    {
+        string file_name = basename(const_cast<char*>(string(file).c_str()));    // basename() modifies its argument
+        auto dir_len = file.size() - file_name.size();
+        string dir = file.substr(0, dir_len);
+        if (*dir.rbegin() != '/')
+        {
+            dir += "/";
+        }
+        string scope_name = strip_suffix(file_name, ".ini");
+
+        // For each scope, create a thread that loads the scope and initializes it.
+        // Each thread gets a promise to indicate when it is finished. When a thread
+        // completes, it fulfils the promise, and pushes its ID onto the finished queue.
+        // We collect exit status from the thread via the future from each promise.
+        promise<void> p;
+        auto f = p.get_future();
+        thread t(scope_thread, runtime_config, scope_name, dir, move(p));
+        auto id = t.get_id();
+        threads[id] = ThreadFuture { move(t), move(f) };
+    }
+
+    // Now wait for the threads to finish (in any order).
+    int num_errors = 0;
+    for (int i = threads.size(); i > 0; --i)
+    {
+        try
+        {
+            auto id = finished_threads.wait_and_pop();
+            auto it = threads.find(id);
+            assert(it != threads.end());
+            it->second.t.join();
+            it->second.f.get();             // This will throw if the thread terminated due to an exception
+        }
+        catch (unity::Exception const& e)
+        {
+            error(e.to_string());
+            ++num_errors;
+        }
+        catch (std::exception const& e)
+        {
+            error(e.what());
+            ++num_errors;
+        }
+        catch (...)
+        {
+            error("unknown exception");
+            ++num_errors;
+        }
+    }
+    return num_errors;
+}
+
+} // namespace
+
+int
+main(int argc, char* argv[])
+{
+    prog_name = basename(argv[0]);
+    if (argc < 3)
+    {
+        cerr << "usage: " << prog_name << " runtime.ini configfile.ini [configfile.ini ...]" << endl;
+        return 2;
+    }
+    char const* const runtime_config = argv[1];
+
+    int exit_status = 0;
+    try
+    {
+        vector<string> config_files;
+        for (int i = 2; i < argc; ++i)
+        {
+            if (!has_suffix(argv[i], ".ini"))
+            {
+                throw ConfigException(string("invalid config file name: \"") + argv[i] + "\": missing .ini extension");
+            }
+            config_files.push_back(argv[i]);
+        }
+
+        exit_status = run_scopes(runtime_config, config_files);
+    }
+    catch (unity::Exception const& e)
+    {
+        error(e.to_string());
+        exit_status = 1;
+    }
+    catch (std::exception const& e)
+    {
+        error(e.what());
+        exit_status = 1;
+    }
+    catch (string const& e)
+    {
+        error("fatal error: " + e);
+        exit_status = 1;
+    }
+    catch (char const* e)
+    {
+        error(string("fatal error: ") + e);
+        exit_status = 1;
+    }
+    catch (...)
+    {
+        error("terminated due to unknown exception");
+        exit_status = 1;
+    }
+
+    return exit_status;
+}

=== modified file 'src/internal/CMakeLists.txt'
--- src/internal/CMakeLists.txt	2013-11-08 14:14:06 +0000
+++ src/internal/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -30,6 +30,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/ResultItemImpl.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/RuntimeConfig.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/RuntimeImpl.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeConfig.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ScopeImpl.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ScopeLoader.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ScopeObject.cpp
@@ -37,10 +38,3 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/UniqueID.cpp
 )
 set(UNITY_SCOPES_LIB_SRC ${UNITY_SCOPES_LIB_SRC} ${SRC} PARENT_SCOPE)
-
-set(CONFIG_FILE_PREFIX "var/unity/api/scopes/config")
-
-add_executable(scope-registry RegistryMain.cpp zmq_middleware/RegistryI.cpp)
-target_link_libraries(scope-registry ${UNITY_SCOPES_LIB} ${OTHER_LIBS})
-
-configure_file(RegistryMain.ini.in ${CMAKE_CURRENT_BINARY_DIR}/RegistryMain.ini)

=== modified file 'src/internal/MiddlewareFactoryConfig.cpp'
--- src/internal/MiddlewareFactoryConfig.cpp	2013-11-01 12:44:48 +0000
+++ src/internal/MiddlewareFactoryConfig.cpp	2013-11-19 02:51:46 +0000
@@ -43,14 +43,14 @@
 {
 }
 
-string MiddlewareFactoryConfig::ice_configfile() const
+string MiddlewareFactoryConfig::zmq_configfile() const
 {
-    return get_string(MIDDLEWARE_FACTORY_CONFIG_GROUP, "Ice.Configfile");
+    return get_string(MIDDLEWARE_FACTORY_CONFIG_GROUP, "Zmq.ConfigFile");
 }
 
 string MiddlewareFactoryConfig::rest_configfile() const
 {
-    return get_string(MIDDLEWARE_FACTORY_CONFIG_GROUP, "REST.Configfile");
+    return get_string(MIDDLEWARE_FACTORY_CONFIG_GROUP, "REST.ConfigFile");
 }
 } // namespace internal
 

=== modified file 'src/internal/RegistryConfig.cpp'
--- src/internal/RegistryConfig.cpp	2013-11-01 12:44:48 +0000
+++ src/internal/RegistryConfig.cpp	2013-11-19 02:51:46 +0000
@@ -18,6 +18,7 @@
 
 #include <scopes/internal/RegistryConfig.h>
 
+#include <scopes/ScopeExceptions.h>
 #include <unity/UnityExceptions.h>
 
 using namespace std;
@@ -45,8 +46,18 @@
         throw InvalidArgumentException("Registry identity cannot be an empty string");
     }
     mw_kind_ = get_middleware(REGISTRY_CONFIG_GROUP, "Middleware");
+    endpointdir_ = get_string(REGISTRY_CONFIG_GROUP, mw_kind_ + ".EndpointDir");
     endpoint_ = get_string(REGISTRY_CONFIG_GROUP, mw_kind_ + ".Endpoint");
-    mw_configfile_ = get_string(REGISTRY_CONFIG_GROUP, mw_kind_ + ".Configfile");
+    mw_configfile_ = get_string(REGISTRY_CONFIG_GROUP, mw_kind_ + ".ConfigFile");
+    scope_installdir_ = get_string(REGISTRY_CONFIG_GROUP, "Scope.InstallDir");
+    scope_group_configdir_ = get_optional_string(REGISTRY_CONFIG_GROUP, "Scope.GroupConfigDir");
+    oem_installdir_ = get_optional_string(REGISTRY_CONFIG_GROUP, "OEM.InstallDir");
+    oem_group_configdir_ = get_optional_string(REGISTRY_CONFIG_GROUP, "OEM.GroupConfigDir");
+    scoperunner_path_ = get_string(REGISTRY_CONFIG_GROUP, "Scoperunner.Path");
+    if (scoperunner_path_[0] != '/')
+    {
+        throw ConfigException(configfile + ": Scoperunner.Path must be an absolute path");
+    }
 }
 
 RegistryConfig::~RegistryConfig() noexcept
@@ -63,6 +74,11 @@
     return mw_kind_;
 }
 
+string RegistryConfig::endpointdir() const
+{
+    return endpointdir_;
+}
+
 string RegistryConfig::endpoint() const
 {
     return endpoint_;
@@ -73,6 +89,31 @@
     return mw_configfile_;
 }
 
+string RegistryConfig::scope_installdir() const
+{
+    return scope_installdir_;
+}
+
+string RegistryConfig::scope_group_configdir() const
+{
+    return scope_group_configdir_;
+}
+
+string RegistryConfig::oem_installdir() const
+{
+    return oem_installdir_;
+}
+
+string RegistryConfig::oem_group_configdir() const
+{
+    return oem_group_configdir_;
+}
+
+string RegistryConfig::scoperunner_path() const
+{
+    return scoperunner_path_;
+}
+
 } // namespace internal
 
 } // namespace scopes

=== removed file 'src/internal/RegistryMain.cpp'
--- src/internal/RegistryMain.cpp	2013-11-18 23:53:56 +0000
+++ src/internal/RegistryMain.cpp	1970-01-01 00:00:00 +0000
@@ -1,83 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical Ltd
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 3 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Authored by: Michi Henning <michi.henning@canonical.com>
- */
-
-#include <scopes/internal/MiddlewareFactory.h>
-#include <scopes/internal/RegistryConfig.h>
-#include <scopes/internal/RegistryObject.h>
-#include <scopes/internal/RuntimeConfig.h>
-#include <scopes/internal/RuntimeImpl.h>
-#include <unity/UnityExceptions.h>
-
-#include <iostream>
-
-using namespace std;
-using namespace unity::api::scopes;
-using namespace unity::api::scopes::internal;
-
-int
-main(int, char*[])
-{
-    int exit_status = 0;
-
-    try
-    {
-        RuntimeImpl::UPtr runtime = RuntimeImpl::create("Registry", "RegistryMain.ini");
-
-        string identity = runtime->registry_identity();
-        RegistryConfig c(identity, runtime->registry_configfile());
-        string mw_kind = c.mw_kind();
-        string mw_endpoint = c.endpoint();
-        string mw_configfile = c.mw_configfile();
-
-        MiddlewareBase::SPtr middleware = runtime->factory()->create(identity, mw_kind, mw_configfile);
-
-        // Instantiate the registry implementation.
-        RegistryObject::SPtr registry(make_shared<RegistryObject>());
-
-        // TODO: populate registry here
-
-        // TODO: temporary hack for demonstration purposes. The actual scopes need to be retrieved from
-        //       configuration instead.
-        auto proxy = middleware->create_scope_proxy("scope-A", "ipc://scope-A");
-        registry->add("scope-A", proxy);
-        proxy = middleware->create_scope_proxy("scope-B", "ipc://scope-B");
-        registry->add("scope-B", proxy);
-        proxy = middleware->create_scope_proxy("scope-C", "ipc://scope-C");
-        registry->add("scope-C", proxy);
-        proxy = middleware->create_scope_proxy("scope-D", "ipc://scope-D");
-        registry->add("scope-D", proxy);
-        proxy = middleware->create_scope_proxy("scope-slow", "ipc://scope-slow");
-        registry->add("scope-slow", proxy);
-
-        // END TODO temporary hack
-
-        // Add the registry implementation to the middleware. This causes
-        // incoming requests to be dispatched to the implementation.
-        middleware->add_registry_object(runtime->registry_identity(), registry);
-
-        // Wait until we are done.
-        middleware->wait_for_shutdown();
-    }
-    catch (unity::Exception const& e)
-    {
-        cerr << e.to_string() << endl;
-        exit_status = 1;
-    }
-
-    return exit_status;
-}

=== removed file 'src/internal/RegistryMain.ini.in'
--- src/internal/RegistryMain.ini.in	2013-09-23 06:13:06 +0000
+++ src/internal/RegistryMain.ini.in	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-[Runtime]
-Registry.Identity = Registry
-Registry.Configfile = Registry.ini
-Default.Middleware = Zmq
-Zmq.Configfile = Zmq.ini
-Factory.Configfile = Factory.ini

=== modified file 'src/internal/RegistryObject.cpp'
--- src/internal/RegistryObject.cpp	2013-11-01 12:44:48 +0000
+++ src/internal/RegistryObject.cpp	2013-11-19 02:51:46 +0000
@@ -67,9 +67,8 @@
     return scopes_;
 }
 
-void RegistryObject::add(std::string const& scope_name, MWScopeProxy const& scope)
+bool RegistryObject::add(std::string const& scope_name, MWScopeProxy const& scope)
 {
-    // If the name is empty, it was sent as empty by the remote client.
     // TODO: also check for names containing a slash, because that won't work if we use
     //       the name for a socket in the file system.
     if (scope_name.empty())
@@ -82,11 +81,14 @@
     auto const& pair = scopes_.insert(make_pair(scope_name, scope));
     if (!pair.second)
     {
-        throw unity::LogicException("Registry: Scope \"" + scope_name + "\" is already in the registry");
+        scopes_.erase(pair.first);
+        scopes_.insert(make_pair(scope_name, scope));
+        return false;
     }
+    return true;
 }
 
-void RegistryObject::remove(std::string const& scope_name)
+bool RegistryObject::remove(std::string const& scope_name)
 {
     // If the name is empty, it was sent as empty by the remote client.
     if (scope_name.empty())
@@ -96,12 +98,7 @@
 
     lock_guard<decltype(mutex_)> lock(mutex_);
 
-    auto const& it = scopes_.find(scope_name);
-    if (it == scopes_.end())
-    {
-        throw unity::LogicException("Registry: Scope \"" + scope_name + "\" is not in the registry");
-    }
-    scopes_.erase(it);
+    return scopes_.erase(scope_name) == 1;
 }
 
 } // namespace internal

=== modified file 'src/internal/RuntimeConfig.cpp'
--- src/internal/RuntimeConfig.cpp	2013-11-01 12:44:48 +0000
+++ src/internal/RuntimeConfig.cpp	2013-11-19 02:51:46 +0000
@@ -37,10 +37,10 @@
 namespace
 {
     const string registry_identity_str = "Registry.Identity";
-    const string registry_configfile_str = "Registry.Configfile";
+    const string registry_configfile_str = "Registry.ConfigFile";
     const string default_middleware_str = "Default.Middleware";
-    const string default_middleware_configfile_str = "Configfile";
-    const string factory_configfile_str = "Factory.Configfile";
+    const string default_middleware_configfile_str = "ConfigFile";
+    const string factory_configfile_str = "Factory.ConfigFile";
 }
 
 RuntimeConfig::RuntimeConfig(string const& configfile) :

=== modified file 'src/internal/RuntimeImpl.cpp'
--- src/internal/RuntimeImpl.cpp	2013-11-01 12:44:48 +0000
+++ src/internal/RuntimeImpl.cpp	2013-11-19 02:51:46 +0000
@@ -68,9 +68,10 @@
         // Create the registry proxy.
         RegistryConfig reg_config(registry_identity_, registry_configfile_);
         string reg_mw_configfile = reg_config.mw_configfile();
-        string reg_endpoint = reg_config.endpoint();
+        registry_endpoint_ = reg_config.endpoint();
+        registry_endpointdir_ = reg_config.endpointdir();
 
-        auto registry_mw_proxy = middleware_->create_registry_proxy(registry_identity_, reg_endpoint);
+        auto registry_mw_proxy = middleware_->create_registry_proxy(registry_identity_, registry_endpoint_);
         registry_ = RegistryImpl::create(registry_mw_proxy, this);
     }
     catch (unity::Exception const& e)
@@ -104,6 +105,9 @@
 {
     if (!destroyed_.exchange(true))
     {
+        // TODO: not good enough. Need to wait for the middleware to stop and for the reaper
+        // to terminate. Otherwise, it's possible that we exit while threads are still running
+        // with undefined behavior.
         registry_ = nullptr;
         middleware_->stop();
         middleware_ = nullptr;
@@ -145,6 +149,16 @@
     return registry_identity_;
 }
 
+string RuntimeImpl::registry_endpointdir() const
+{
+    return registry_endpointdir_;
+}
+
+string RuntimeImpl::registry_endpoint() const
+{
+    return registry_endpoint_;
+}
+
 Reaper::SPtr RuntimeImpl::reply_reaper() const
 {
     // We lazily create a reaper the first time we are asked for it, which happens when the first query is created.

=== added file 'src/internal/ScopeConfig.cpp'
--- src/internal/ScopeConfig.cpp	1970-01-01 00:00:00 +0000
+++ src/internal/ScopeConfig.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,70 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/internal/ScopeConfig.h>
+
+#include <unity/UnityExceptions.h>
+
+using namespace std;
+
+namespace unity
+{
+
+namespace api
+{
+
+namespace scopes
+{
+
+namespace internal
+{
+
+namespace
+{
+    const string overrideable_str = "Override";
+}
+
+ScopeConfig::ScopeConfig(string const& configfile) :
+    ConfigBase(configfile)
+{
+    try
+    {
+        overrideable_ = parser()->get_boolean(SCOPE_CONFIG_GROUP, overrideable_str);
+    }
+    catch (LogicException const&)
+    {
+        overrideable_ = false;
+    }
+}
+
+ScopeConfig::~ScopeConfig() noexcept
+{
+}
+
+bool ScopeConfig::overrideable() const
+{
+    return overrideable_;
+}
+
+} // namespace internal
+
+} // namespace scopes
+
+} // namespace api
+
+} // namespace unity

=== modified file 'src/internal/zmq_middleware/CMakeLists.txt'
--- src/internal/zmq_middleware/CMakeLists.txt	2013-09-23 06:13:06 +0000
+++ src/internal/zmq_middleware/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -14,6 +14,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/ScopeI.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ServantBase.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/VariantConverter.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/ZmqConfig.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ZmqMiddleware.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ZmqException.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ZmqObject.cpp

=== added file 'src/internal/zmq_middleware/ZmqConfig.cpp'
--- src/internal/zmq_middleware/ZmqConfig.cpp	1970-01-01 00:00:00 +0000
+++ src/internal/zmq_middleware/ZmqConfig.cpp	2013-11-19 02:51:46 +0000
@@ -0,0 +1,77 @@
+/*
+ * Copyright (C) 2013 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Michi Henning <michi.henning@canonical.com>
+ */
+
+#include <scopes/internal/zmq_middleware/ZmqConfig.h>
+
+using namespace std;
+
+namespace unity
+{
+
+namespace api
+{
+
+namespace scopes
+{
+
+namespace internal
+{
+
+const char* ZmqConfig::ZMQ_CONFIG_GROUP = "Zmq";
+
+namespace
+{
+    const string public_dir_str = "EndpointDir.Public";
+    const string private_dir_str = "EndpointDir.Private";
+}
+
+ZmqConfig::ZmqConfig(string const& configfile) :
+    ConfigBase(configfile)
+{
+    public_dir_ = get_string(ZMQ_CONFIG_GROUP, public_dir_str);
+
+    // Private directory is not needed by all processes. It is retrieved
+    // on demand during adapter creation.
+}
+
+ZmqConfig::~ZmqConfig() noexcept
+{
+}
+
+string ZmqConfig::public_dir() const
+{
+    return public_dir_;
+}
+
+string ZmqConfig::private_dir() const
+{
+    lock_guard<mutex> lock(mutex_);
+    if (private_dir_.empty())    // Initialize first time only
+    {
+        private_dir_ = get_string(ZMQ_CONFIG_GROUP, private_dir_str);
+    }
+    return private_dir_;
+}
+
+} // namespace internal
+
+} // namespace scopes
+
+} // namespace api
+
+} // namespace unity

=== modified file 'src/internal/zmq_middleware/ZmqMiddleware.cpp'
--- src/internal/zmq_middleware/ZmqMiddleware.cpp	2013-11-01 12:44:48 +0000
+++ src/internal/zmq_middleware/ZmqMiddleware.cpp	2013-11-19 02:51:46 +0000
@@ -18,6 +18,7 @@
 
 #include <scopes/internal/zmq_middleware/ZmqMiddleware.h>
 
+#include <scopes/internal/RuntimeImpl.h>
 #include <scopes/internal/zmq_middleware/ConnectionPool.h>
 #include <scopes/internal/zmq_middleware/ObjectAdapter.h>
 #include <scopes/internal/zmq_middleware/QueryI.h>
@@ -64,11 +65,10 @@
 try :
     MiddlewareBase(runtime),
     server_name_(server_name),
-    state_(Stopped)
+    state_(Stopped),
+    config_(configfile)
 {
     assert(!server_name.empty());
-
-    // TODO: read config from file (thread pool size, invocation timeout, etc.
 }
 catch (zmqpp::exception const& e)
 {
@@ -178,6 +178,21 @@
     return proxy;
 }
 
+MWScopeProxy ZmqMiddleware::create_scope_proxy(string const& identity)
+{
+    MWScopeProxy proxy;
+    try
+    {
+        string endpoint = "ipc://" + config_.private_dir() + "/" + identity;
+        proxy.reset(new ZmqScope(this, endpoint, identity));
+    }
+    catch (zmqpp::exception const& e)
+    {
+        rethrow_zmq_ex(e);
+    }
+    return proxy;
+}
+
 MWScopeProxy ZmqMiddleware::create_scope_proxy(string const& identity, string const& endpoint)
 {
     MWScopeProxy proxy;
@@ -200,7 +215,7 @@
     try
     {
         shared_ptr<QueryCtrlI> qci(make_shared<QueryCtrlI>(ctrl));
-        auto adapter = find_adapter(server_name_ + ctrl_suffix);
+        auto adapter = find_adapter(server_name_ + ctrl_suffix, config_.private_dir());
         function<void()> df;
         auto proxy = safe_add(df, adapter, "", qci);
         ctrl->set_disconnect_function(df);
@@ -221,7 +236,7 @@
     try
     {
         shared_ptr<QueryI> qi(make_shared<QueryI>(query));
-        auto adapter = find_adapter(server_name_ + query_suffix);
+        auto adapter = find_adapter(server_name_ + query_suffix, config_.private_dir());
         function<void()> df;
         auto proxy = safe_add(df, adapter, "", qi);
         query->set_disconnect_function(df);
@@ -244,7 +259,7 @@
     try
     {
         shared_ptr<RegistryI> ri(make_shared<RegistryI>(registry));
-        auto adapter = find_adapter(server_name_);
+        auto adapter = find_adapter(server_name_, runtime()->registry_endpointdir());
         function<void()> df;
         auto proxy = safe_add(df, adapter, identity, ri);
         registry->set_disconnect_function(df);
@@ -265,7 +280,7 @@
     try
     {
         shared_ptr<ReplyI> ri(make_shared<ReplyI>(reply));
-        auto adapter = find_adapter(server_name_ + reply_suffix);
+        auto adapter = find_adapter(server_name_ + reply_suffix, config_.public_dir());
         function<void()> df;
         auto proxy = safe_add(df, adapter, "", ri);
         reply->set_disconnect_function(df);
@@ -287,7 +302,7 @@
     try
     {
         shared_ptr<ScopeI> si(make_shared<ScopeI>(scope));
-        auto adapter = find_adapter(server_name_);
+        auto adapter = find_adapter(server_name_, config_.private_dir());
         function<void()> df;
         auto proxy = safe_add(df, adapter, identity, si);
         scope->set_disconnect_function(df);
@@ -326,7 +341,7 @@
 
 } // namespace
 
-shared_ptr<ObjectAdapter> ZmqMiddleware::find_adapter(string const& name)
+shared_ptr<ObjectAdapter> ZmqMiddleware::find_adapter(string const& name, string const& endpoint_dir)
 {
     lock_guard<mutex> lock(mutex_);
 
@@ -341,7 +356,7 @@
     RequestType type;
     if (has_suffix(name, query_suffix))
     {
-        // The query adapter is single or multi-thread and supports oneway operations only.
+        // The query adapter is single or multi-threaded and supports oneway operations only.
         // TODO: get pool size from config
         pool_size = 1;
         type = RequestType::Oneway;
@@ -366,9 +381,17 @@
         pool_size = 1;
         type = RequestType::Twoway;
     }
-    // TODO: get directory of adapter from config
+
     // The query adapter is always inproc.
-    string endpoint = (has_suffix(name, query_suffix) ? "inproc://" : "ipc://") + name;
+    string endpoint;
+    if (has_suffix(name, query_suffix))
+    {
+        endpoint = "inproc://" + name;
+    }
+    else
+    {
+        endpoint = "ipc://" + endpoint_dir + "/" + name;
+    }
 
     shared_ptr<ObjectAdapter> a(new ObjectAdapter(*this, name, endpoint, type, pool_size));
     a->activate();

=== modified file 'test/gtest/unity/api/scopes/Runtime/CMakeLists.txt'
--- test/gtest/unity/api/scopes/Runtime/CMakeLists.txt	2013-09-23 06:13:06 +0000
+++ test/gtest/unity/api/scopes/Runtime/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,6 +1,7 @@
-configure_file(Factory.ini.in Factory.ini)
-configure_file(Registry.ini.in Registry.ini)
-configure_file(Runtime.ini.in Runtime.ini)
+configure_file(Factory.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Factory.ini)
+configure_file(Registry.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Registry.ini)
+configure_file(Runtime.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Runtime.ini)
+configure_file(Zmq.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Zmq.ini)
 
 add_executable(Runtime_test Runtime_test.cpp)
 target_link_libraries(Runtime_test ${TESTLIBS})

=== modified file 'test/gtest/unity/api/scopes/Runtime/Registry.ini.in'
--- test/gtest/unity/api/scopes/Runtime/Registry.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/Runtime/Registry.ini.in	2013-11-19 02:51:46 +0000
@@ -1,4 +1,7 @@
 [Registry]
 Middleware = Zmq
-Zmq.Endpoint = ipc:///tmp/socket_for_registry
-Zmq.Configfile = Zmq.ini
+Zmq.Endpoint = ipc://@CMAKE_CURRENT_BINARY_DIR@/socket_for_registry
+Zmq.EndpointDir = @CMAKE_CURRENT_BINARY_DIR@
+Zmq.ConfigFile = Zmq.ini
+Scope.InstallDir = /unused
+Scoperunner.Path = /unused

=== modified file 'test/gtest/unity/api/scopes/Runtime/Runtime.ini.in'
--- test/gtest/unity/api/scopes/Runtime/Runtime.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/Runtime/Runtime.ini.in	2013-11-19 02:51:46 +0000
@@ -1,6 +1,6 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Zmq
-Factory.Configfile = Factory.ini
-Zmq.Configfile = Zmq.ini
+Factory.ConfigFile = Factory.ini
+Zmq.ConfigFile = Zmq.ini

=== added file 'test/gtest/unity/api/scopes/Runtime/Zmq.ini.in'
--- test/gtest/unity/api/scopes/Runtime/Zmq.ini.in	1970-01-01 00:00:00 +0000
+++ test/gtest/unity/api/scopes/Runtime/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,2 @@
+[Zmq]
+EndpointDir.Public = @CMAKE_CURRENT_BINARY_DIR@

=== modified file 'test/gtest/unity/api/scopes/internal/MiddlewareFactoryConfig/Factory.ini.in'
--- test/gtest/unity/api/scopes/internal/MiddlewareFactoryConfig/Factory.ini.in	2013-08-06 01:51:26 +0000
+++ test/gtest/unity/api/scopes/internal/MiddlewareFactoryConfig/Factory.ini.in	2013-11-19 02:51:46 +0000
@@ -1,3 +1,3 @@
 [MiddlewareFactory]
-Ice.Configfile = Ice.Config
-REST.Configfile = REST.Config
+Zmq.ConfigFile = Zmq.ini
+REST.ConfigFile = REST.ini

=== modified file 'test/gtest/unity/api/scopes/internal/MiddlewareFactoryConfig/MiddlewareFactoryConfig_test.cpp'
--- test/gtest/unity/api/scopes/internal/MiddlewareFactoryConfig/MiddlewareFactoryConfig_test.cpp	2013-11-01 12:44:48 +0000
+++ test/gtest/unity/api/scopes/internal/MiddlewareFactoryConfig/MiddlewareFactoryConfig_test.cpp	2013-11-19 02:51:46 +0000
@@ -26,6 +26,6 @@
 TEST(MiddlewareFactoryConfig, basic)
 {
     MiddlewareFactoryConfig c("Factory.ini");
-    EXPECT_EQ("Ice.Config", c.ice_configfile());
-    EXPECT_EQ("REST.Config", c.rest_configfile());
+    EXPECT_EQ("Zmq.ini", c.zmq_configfile());
+    EXPECT_EQ("REST.ini", c.rest_configfile());
 }

=== modified file 'test/gtest/unity/api/scopes/internal/RegistryConfig/CMakeLists.txt'
--- test/gtest/unity/api/scopes/internal/RegistryConfig/CMakeLists.txt	2013-08-05 06:02:03 +0000
+++ test/gtest/unity/api/scopes/internal/RegistryConfig/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,4 +1,5 @@
 configure_file(Registry.ini.in Registry.ini)
+configure_file(ScoperunnerRelativePath.ini.in ScoperunnerRelativePath.ini)
 
 add_executable(RegistryConfig_test RegistryConfig_test.cpp)
 target_link_libraries(RegistryConfig_test ${TESTLIBS})

=== modified file 'test/gtest/unity/api/scopes/internal/RegistryConfig/Registry.ini.in'
--- test/gtest/unity/api/scopes/internal/RegistryConfig/Registry.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RegistryConfig/Registry.ini.in	2013-11-19 02:51:46 +0000
@@ -1,4 +1,7 @@
 [Registry]
 Middleware = Zmq
 Zmq.Endpoint = ipc:///tmp/socket_for_registry
-Zmq.Configfile = Zmq.ini
+Zmq.EndpointDir = /tmp/socket_for_registry
+Zmq.ConfigFile = Zmq.ini
+Scope.InstallDir = /SomeDir
+Scoperunner.Path = /SomeAbsolutePath

=== modified file 'test/gtest/unity/api/scopes/internal/RegistryConfig/RegistryConfig_test.cpp'
--- test/gtest/unity/api/scopes/internal/RegistryConfig/RegistryConfig_test.cpp	2013-11-01 12:44:48 +0000
+++ test/gtest/unity/api/scopes/internal/RegistryConfig/RegistryConfig_test.cpp	2013-11-19 02:51:46 +0000
@@ -49,3 +49,18 @@
                   e.to_string());
     }
 }
+
+TEST(RegistryConfig, ScoperunnerRelativePath)
+{
+    try
+    {
+        RegistryConfig c("Registry", "ScoperunnerRelativePath.ini");
+        FAIL();
+    }
+    catch (ConfigException const& e)
+    {
+        EXPECT_EQ("unity::api::scopes::ConfigException: ScoperunnerRelativePath.ini: Scoperunner.Path "
+                  "must be an absolute path",
+                  e.to_string());
+    }
+}

=== added file 'test/gtest/unity/api/scopes/internal/RegistryConfig/ScoperunnerRelativePath.ini.in'
--- test/gtest/unity/api/scopes/internal/RegistryConfig/ScoperunnerRelativePath.ini.in	1970-01-01 00:00:00 +0000
+++ test/gtest/unity/api/scopes/internal/RegistryConfig/ScoperunnerRelativePath.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,7 @@
+[Registry]
+Middleware = Zmq
+Zmq.Endpoint = ipc:///tmp/socket_for_registry
+Zmq.EndpointDir = /tmp/socket_for_registry
+Zmq.ConfigFile = Zmq.ini
+Scope.InstallDir = /SomeDir
+Scoperunner.Path = SomeRelativePath

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/BadMW.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/BadMW.ini.in	2013-08-05 06:02:03 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/BadMW.ini.in	2013-11-19 02:51:46 +0000
@@ -1,5 +1,5 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Foo
-Factory.Configfile = Factory.ini
+Factory.ConfigFile = Factory.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/BadRegID.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/BadRegID.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/BadRegID.ini.in	2013-11-19 02:51:46 +0000
@@ -1,5 +1,5 @@
 [Runtime]
 Registry.Identity = Regi/stry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Zmq
-Factory.Configfile = Factory.ini
+Factory.ConfigFile = Factory.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/FacFileEmpty.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/FacFileEmpty.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/FacFileEmpty.ini.in	2013-11-19 02:51:46 +0000
@@ -1,6 +1,6 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Zmq
-Factory.Configfile =
-Zmq.Configfile = Zmq.ini
+Factory.ConfigFile =
+Zmq.ConfigFile = Zmq.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/MWEmpty.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/MWEmpty.ini.in	2013-08-05 06:02:03 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/MWEmpty.ini.in	2013-11-19 02:51:46 +0000
@@ -1,5 +1,5 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware =
-Factory.Configfile = Factory.ini
+Factory.ConfigFile = Factory.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/RegFileEmpty.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/RegFileEmpty.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/RegFileEmpty.ini.in	2013-11-19 02:51:46 +0000
@@ -1,5 +1,5 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile =
+Registry.ConfigFile =
 Default.Middleware = Zmq
-Factory.Configfile = Factory.ini
+Factory.ConfigFile = Factory.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/RegIDEmpty.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/RegIDEmpty.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/RegIDEmpty.ini.in	2013-11-19 02:51:46 +0000
@@ -1,5 +1,5 @@
 [Runtime]
 Registry.Identity =
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Zmq
-Factory.Configfile = Factory.ini
+Factory.ConfigFile = Factory.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/Runtime.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/Runtime.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/Runtime.ini.in	2013-11-19 02:51:46 +0000
@@ -1,6 +1,6 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Zmq
-Factory.Configfile = Factory.ini
-Zmq.Configfile = Zmq.ini
+Factory.ConfigFile = Factory.ini
+Zmq.ConfigFile = Zmq.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeConfig/RuntimeConfig_test.cpp'
--- test/gtest/unity/api/scopes/internal/RuntimeConfig/RuntimeConfig_test.cpp	2013-11-01 12:44:48 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeConfig/RuntimeConfig_test.cpp	2013-11-19 02:51:46 +0000
@@ -72,7 +72,7 @@
     }
     catch (ConfigException const& e)
     {
-        EXPECT_EQ("unity::api::scopes::ConfigException: \"RegFileEmpty.ini\": Illegal empty value for Registry.Configfile",
+        EXPECT_EQ("unity::api::scopes::ConfigException: \"RegFileEmpty.ini\": Illegal empty value for Registry.ConfigFile",
                   e.to_string());
     }
 }
@@ -115,7 +115,7 @@
     }
     catch (ConfigException const& e)
     {
-        EXPECT_EQ("unity::api::scopes::ConfigException: \"FacFileEmpty.ini\": Illegal empty value for Factory.Configfile",
+        EXPECT_EQ("unity::api::scopes::ConfigException: \"FacFileEmpty.ini\": Illegal empty value for Factory.ConfigFile",
                   e.to_string());
     }
 }

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeImpl/CMakeLists.txt'
--- test/gtest/unity/api/scopes/internal/RuntimeImpl/CMakeLists.txt	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeImpl/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,5 +1,5 @@
 configure_file(Factory.ini.in Factory.ini)
-configure_file(Zmq.ini.in Zmq.Config)
+configure_file(Zmq.ini.in Zmq.ini)
 configure_file(Registry.ini.in Registry.ini)
 configure_file(Runtime.ini.in Runtime.ini)
 

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeImpl/Registry.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeImpl/Registry.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeImpl/Registry.ini.in	2013-11-19 02:51:46 +0000
@@ -1,4 +1,8 @@
 [Registry]
 Middleware = Zmq
 Zmq.Endpoint = ipc:///tmp/socket_for_registry
-Zmq.Configfile = Zmq.ini
+Zmq.EndpointDir = /tmp
+Zmq.ConfigFile = Zmq.ini
+Scoperunner.Path = /SomePath
+Scope.ConfigDir = /tmp
+Scope.InstallDir = /tmp

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeImpl/Runtime.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeImpl/Runtime.ini.in	2013-09-17 08:02:23 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeImpl/Runtime.ini.in	2013-11-19 02:51:46 +0000
@@ -1,6 +1,6 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = Registry.ini
+Registry.ConfigFile = Registry.ini
 Default.Middleware = Zmq
-Factory.Configfile = Factory.ini
-Zmq.Configfile = Zmq.ini
+Factory.ConfigFile = Factory.ini
+Zmq.ConfigFile = Zmq.ini

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeImpl/RuntimeImpl_test.cpp'
--- test/gtest/unity/api/scopes/internal/RuntimeImpl/RuntimeImpl_test.cpp	2013-11-01 12:44:48 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeImpl/RuntimeImpl_test.cpp	2013-11-19 02:51:46 +0000
@@ -29,6 +29,7 @@
 
 TEST(RuntimeImpl, basic)
 {
+try{
     RuntimeImpl::UPtr rt = RuntimeImpl::create("testscope");
 
     EXPECT_TRUE(rt->registry().get() != nullptr);
@@ -60,6 +61,11 @@
                   e.to_string());
     }
 }
+catch(unity::Exception const& e)
+{
+    cout << e.to_string() << endl;
+}
+}
 
 TEST(RuntimeImpl, error)
 {

=== modified file 'test/gtest/unity/api/scopes/internal/RuntimeImpl/Zmq.ini.in'
--- test/gtest/unity/api/scopes/internal/RuntimeImpl/Zmq.ini.in	2013-09-18 02:38:26 +0000
+++ test/gtest/unity/api/scopes/internal/RuntimeImpl/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -1,1 +1,2 @@
 [Zmq]
+EndpointDir.Public = /tmp

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/CMakeLists.txt'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/CMakeLists.txt	2013-09-05 04:23:07 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,3 +1,5 @@
+configure_file(Zmq.ini.in Zmq.ini)
+
 add_executable(ObjectAdapter_test ObjectAdapter_test.cpp)
 target_link_libraries(ObjectAdapter_test ${LIBS} ${TESTLIBS})
 

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/ObjectAdapter_test.cpp'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/ObjectAdapter_test.cpp	2013-11-01 12:47:46 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/ObjectAdapter_test.cpp	2013-11-19 02:51:46 +0000
@@ -53,7 +53,7 @@
 
 TEST(ObjectAdapter, basic)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     // Instantiate and destroy oneway and twoway adapters with single and multiple threads.
@@ -131,7 +131,7 @@
 
 TEST(ObjectAdapter, state_change)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     {
@@ -163,7 +163,7 @@
 
 TEST(ObjectAdapter, wait_for_shutdown)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     // Start the adapter and call shutdown() from a different thread after a delay, and wait for the
@@ -210,7 +210,7 @@
 
 TEST(ObjectAdapter, add_remove_find)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -272,7 +272,7 @@
 
 TEST(ObjectAdapter, dispatch_oneway_to_twoway)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -307,7 +307,7 @@
 
 TEST(ObjectAdapter, dispatch_twoway_to_oneway)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -333,7 +333,7 @@
 
 TEST(ObjectAdapter, dispatch_not_exist)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -374,7 +374,7 @@
 
 TEST(ObjectAdapter, bad_header)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -408,7 +408,7 @@
 
 TEST(ObjectAdapter, corrupt_header)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -443,7 +443,7 @@
 
 TEST(ObjectAdapter, invoke_ok)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -494,7 +494,7 @@
 
 TEST(ObjectAdapter, invoke_object_not_exist)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -537,7 +537,7 @@
 
 TEST(ObjectAdapter, invoke_operation_not_exist)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -650,7 +650,7 @@
 
 TEST(ObjectAdapter, twoway_threading)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();
@@ -683,7 +683,7 @@
 
 TEST(ObjectAdapter, oneway_threading)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini",
                      (RuntimeImpl*)0x1);
 
     wait();

=== added file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini.in'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini.in	1970-01-01 00:00:00 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ObjectAdapter/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,2 @@
+[Zmq]
+EndpointDir.Public = /tmp

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/CMakeLists.txt'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/CMakeLists.txt	2013-09-23 06:13:06 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,6 +1,7 @@
 configure_file(Factory.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Factory.ini)
 configure_file(Registry.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Registry.ini)
 configure_file(Runtime.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Runtime.ini)
+configure_file(Zmq.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Zmq.ini)
 
 add_executable(RegistryI_test RegistryI_test.cpp)
 target_link_libraries(RegistryI_test ${LIBS} ${TESTLIBS})

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Registry.ini.in'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Registry.ini.in	2013-09-23 06:13:06 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Registry.ini.in	2013-11-19 02:51:46 +0000
@@ -3,5 +3,8 @@
 
 [Registry]
 Middleware = Zmq
-Zmq.Endpoint = ipc://./Registry
-Zmq.Configfile = Zmq.ini
+Zmq.Endpoint = ipc://@CMAKE_CURRENT_BINARY_DIR@/Registry
+Zmq.EndpointDir = @CMAKE_CURRENT_BINARY_DIR@
+Zmq.ConfigFile = Zmq.ini
+Scope.InstallDir = /tmp
+Scoperunner.Path = /tmp

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/RegistryI_test.cpp'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/RegistryI_test.cpp	2013-11-01 12:47:46 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/RegistryI_test.cpp	2013-11-19 02:51:46 +0000
@@ -39,6 +39,8 @@
 
 TEST(RegistryI, find)
 {
+try
+{
     RuntimeImpl::UPtr runtime = RuntimeImpl::create(
         "Registry", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Runtime.ini");
 
@@ -52,12 +54,17 @@
     RegistryObject::SPtr ro(make_shared<RegistryObject>());
     auto registry = middleware->add_registry_object(identity, ro);
     auto proxy = middleware->create_scope_proxy("scope1", "ipc:///tmp/scope1");
-    ro->add("scope1", proxy);
+    EXPECT_TRUE(ro->add("scope1", proxy));
 
     auto r = runtime->registry();
     auto scope = r->find("scope1");
     EXPECT_TRUE(scope.get());
 }
+catch(unity::Exception const& e)
+{
+    cout << e.to_string() << endl;
+}
+}
 
 TEST(RegistryI, list)
 {
@@ -79,7 +86,7 @@
     EXPECT_TRUE(scopes.empty());
 
     auto proxy = middleware->create_scope_proxy("scope1", "ipc:///tmp/scope1");
-    ro->add("scope1", proxy);
+    EXPECT_TRUE(ro->add("scope1", proxy));
     scopes = r->list();
     EXPECT_EQ(1, scopes.size());
     EXPECT_NE(scopes.end(), scopes.find("scope1"));
@@ -92,6 +99,54 @@
     for (int i = 0; i < 1000; ++i)
     {
         string long_id = "0000000000000000000000000000000000000000000000" + to_string(i);
+        EXPECT_TRUE(ro->add(long_id, proxy));
+        ids.insert(long_id);
+    }
+    scopes = r->list();
+    EXPECT_EQ(1000, scopes.size());
+    for (auto& id : ids)
+    {
+        auto it = scopes.find(id);
+        EXPECT_NE(scopes.end(), it);
+        EXPECT_NE(ids.end(), ids.find(it->first));
+    }
+}
+
+TEST(RegistryI, add_remove)
+{
+    RuntimeImpl::UPtr runtime = RuntimeImpl::create(
+        "Registry", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Runtime.ini");
+
+    string identity = runtime->registry_identity();
+    RegistryConfig c(identity, runtime->registry_configfile());
+    string mw_kind = c.mw_kind();
+    string mw_endpoint = c.endpoint();
+    string mw_configfile = c.mw_configfile();
+
+    MiddlewareBase::SPtr middleware = runtime->factory()->create(identity, mw_kind, mw_configfile);
+    RegistryObject::SPtr ro(make_shared<RegistryObject>());
+    auto registry = middleware->add_registry_object(identity, ro);
+
+    auto r = runtime->registry();
+    auto scopes = r->list();
+    EXPECT_TRUE(scopes.empty());
+
+    auto proxy = middleware->create_scope_proxy("scope1", "ipc:///tmp/scope1");
+    EXPECT_TRUE(ro->add("scope1", proxy));
+    scopes = r->list();
+    EXPECT_EQ(1, scopes.size());
+    EXPECT_NE(scopes.end(), scopes.find("scope1"));
+    EXPECT_FALSE(ro->add("scope1", proxy));
+
+    EXPECT_TRUE(ro->remove("scope1"));
+    scopes = r->list();
+    EXPECT_EQ(0, scopes.size());
+    EXPECT_FALSE(ro->remove("scope1"));
+
+    set<string> ids;
+    for (int i = 0; i < 1000; ++i)
+    {
+        string long_id = "0000000000000000000000000000000000000000000000" + to_string(i);
         ro->add(long_id, proxy);
         ids.insert(long_id);
     }
@@ -161,19 +216,6 @@
 
     try
     {
-        auto proxy = middleware->create_scope_proxy("scope1", "ipc:///tmp/scope1");
-        ro->add("x", proxy);
-        ro->add("x", proxy);
-        FAIL();
-    }
-    catch (LogicException const& e)
-    {
-        EXPECT_EQ("unity::LogicException: Registry: Scope \"x\" is already in the registry",
-                  e.to_string());
-    }
-
-    try
-    {
         ro->remove("");
         FAIL();
     }
@@ -182,15 +224,4 @@
         EXPECT_EQ("unity::InvalidArgumentException: Registry: Cannot remove scope with empty name",
                   e.to_string());
     }
-
-    try
-    {
-        ro->remove("fred");
-        FAIL();
-    }
-    catch (LogicException const& e)
-    {
-        EXPECT_EQ("unity::LogicException: Registry: Scope \"fred\" is not in the registry",
-                  e.to_string());
-    }
 }

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Runtime.ini.in'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Runtime.ini.in	2013-09-23 06:13:06 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Runtime.ini.in	2013-11-19 02:51:46 +0000
@@ -1,6 +1,6 @@
 [Runtime]
 Registry.Identity = Registry
-Registry.Configfile = @CMAKE_CURRENT_BINARY_DIR@/Registry.ini
+Registry.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Registry.ini
 Default.Middleware = Zmq
-Zmq.Configfile = @CMAKE_CURRENT_BINARY_DIR@/Zmq.ini
-Factory.Configfile = @CMAKE_CURRENT_BINARY_DIR@/Factory.ini
+Zmq.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Zmq.ini
+Factory.ConfigFile = @CMAKE_CURRENT_BINARY_DIR@/Factory.ini

=== added file 'test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Zmq.ini.in'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Zmq.ini.in	1970-01-01 00:00:00 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/RegistryI/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,2 @@
+[Zmq]
+EndpointDir.Public = @CMAKE_CURRENT_BINARY_DIR@

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/CMakeLists.txt'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/CMakeLists.txt	2013-09-13 05:04:40 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,3 +1,5 @@
+configure_file(Zmq.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Zmq.ini)
+
 add_executable(ServantBase_test ServantBase_test.cpp)
 target_link_libraries(ServantBase_test ${LIBS} ${TESTLIBS})
 

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/ServantBase_test.cpp'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/ServantBase_test.cpp	2013-11-01 12:47:46 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/ServantBase_test.cpp	2013-11-19 02:51:46 +0000
@@ -93,7 +93,7 @@
 
 TEST(ServantBase, success)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/Zmq.ini",
                      (RuntimeImpl*)0x1);
     ObjectAdapter a(mw, "testscope", "ipc://testscope", RequestType::Twoway, 1);
     Current current;
@@ -110,7 +110,7 @@
 
 TEST(ServantBase, exceptions)
 {
-    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+    ZmqMiddleware mw("testscope", TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/Zmq.ini",
                      (RuntimeImpl*)0x1);
     ObjectAdapter a(mw, "testscope", "ipc://testscope", RequestType::Twoway, 1);
     Current current;

=== added file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/Zmq.ini.in'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/Zmq.ini.in	1970-01-01 00:00:00 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ServantBase/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,2 @@
+[Zmq]
+EndpointDir.Public = @CMAKE_CURRENT_BINARY_DIR@

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/CMakeLists.txt'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/CMakeLists.txt	2013-09-05 04:23:07 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/CMakeLists.txt	2013-11-19 02:51:46 +0000
@@ -1,3 +1,5 @@
+configure_file(Zmq.ini.in ${CMAKE_CURRENT_BINARY_DIR}/Zmq.ini)
+
 add_executable(ZmqMiddleware_test ZmqMiddleware_test.cpp)
 target_link_libraries(ZmqMiddleware_test ${LIBS} ${TESTLIBS})
 

=== added file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/Zmq.ini.in'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/Zmq.ini.in	1970-01-01 00:00:00 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/Zmq.ini.in	2013-11-19 02:51:46 +0000
@@ -0,0 +1,2 @@
+[Zmq]
+EndpointDir.Public = @CMAKE_CURRENT_BINARY_DIR@

=== modified file 'test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/ZmqMiddleware_test.cpp'
--- test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/ZmqMiddleware_test.cpp	2013-11-01 12:44:48 +0000
+++ test/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/ZmqMiddleware_test.cpp	2013-11-19 02:51:46 +0000
@@ -29,7 +29,7 @@
 TEST(ZmqMiddleware, basic)
 {
     ZmqMiddleware im("testscope",
-                     TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/Zmq.config",
+                     TEST_BUILD_ROOT "/gtest/unity/api/scopes/internal/zmq_middleware/ZmqMiddleware/Zmq.ini",
                      (RuntimeImpl*)0x1);
     im.start();
     sleep(1);

